"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.createServerCredentialsWithInterceptors=exports.ServerCredentials=void 0;const tls_helpers_1=require("./tls-helpers");class ServerCredentials{constructor(){this.watchers=new Set,this.latestContextOptions=null}_addWatcher(e){this.watchers.add(e)}_removeWatcher(e){this.watchers.delete(e)}updateSecureContextOptions(e){this.latestContextOptions=e||null;for(const e of this.watchers)e(this.latestContextOptions)}_getSettings(){return this.latestContextOptions}_getInterceptors(){return[]}static createInsecure(){return new InsecureServerCredentials}static createSsl(e,r,t=!1){var s;if(null!==e&&!Buffer.isBuffer(e))throw new TypeError("rootCerts must be null or a Buffer");if(!Array.isArray(r))throw new TypeError("keyCertPairs must be an array");if("boolean"!=typeof t)throw new TypeError("checkClientCertificate must be a boolean");const i=[],n=[];for(let e=0;e<r.length;e++){const t=r[e];if(null===t||"object"!=typeof t)throw new TypeError(`keyCertPair[${e}] must be an object`);if(!Buffer.isBuffer(t.private_key))throw new TypeError(`keyCertPair[${e}].private_key must be a Buffer`);if(!Buffer.isBuffer(t.cert_chain))throw new TypeError(`keyCertPair[${e}].cert_chain must be a Buffer`);i.push(t.cert_chain),n.push(t.private_key)}return new SecureServerCredentials({ca:null!==(s=null!=e?e:(0,tls_helpers_1.getDefaultRootsData)())&&void 0!==s?s:void 0,cert:i,key:n,requestCert:t,ciphers:tls_helpers_1.CIPHER_SUITES})}}exports.ServerCredentials=ServerCredentials;class InsecureServerCredentials extends ServerCredentials{_isSecure(){return!1}_getSettings(){return null}_equals(e){return e instanceof InsecureServerCredentials}}class SecureServerCredentials extends ServerCredentials{constructor(e){super(),this.options=e}_isSecure(){return!0}_getSettings(){return this.options}_equals(e){if(this===e)return!0;if(!(e instanceof SecureServerCredentials))return!1;if(Buffer.isBuffer(this.options.ca)&&Buffer.isBuffer(e.options.ca)){if(!this.options.ca.equals(e.options.ca))return!1}else if(this.options.ca!==e.options.ca)return!1;if(Array.isArray(this.options.cert)&&Array.isArray(e.options.cert)){if(this.options.cert.length!==e.options.cert.length)return!1;for(let r=0;r<this.options.cert.length;r++){const t=this.options.cert[r],s=e.options.cert[r];if(Buffer.isBuffer(t)&&Buffer.isBuffer(s)){if(!t.equals(s))return!1}else if(t!==s)return!1}}else if(this.options.cert!==e.options.cert)return!1;if(Array.isArray(this.options.key)&&Array.isArray(e.options.key)){if(this.options.key.length!==e.options.key.length)return!1;for(let r=0;r<this.options.key.length;r++){const t=this.options.key[r],s=e.options.key[r];if(Buffer.isBuffer(t)&&Buffer.isBuffer(s)){if(!t.equals(s))return!1}else if(t!==s)return!1}}else if(this.options.key!==e.options.key)return!1;return this.options.requestCert===e.options.requestCert}}class InterceptorServerCredentials extends ServerCredentials{constructor(e,r){super(),this.childCredentials=e,this.interceptors=r}_isSecure(){return this.childCredentials._isSecure()}_equals(e){if(!(e instanceof InterceptorServerCredentials))return!1;if(!this.childCredentials._equals(e.childCredentials))return!1;if(this.interceptors.length!==e.interceptors.length)return!1;for(let r=0;r<this.interceptors.length;r++)if(this.interceptors[r]!==e.interceptors[r])return!1;return!0}_getInterceptors(){return this.interceptors}_addWatcher(e){this.childCredentials._addWatcher(e)}_removeWatcher(e){this.childCredentials._removeWatcher(e)}}function createServerCredentialsWithInterceptors(e,r){return new InterceptorServerCredentials(e,r)}exports.createServerCredentialsWithInterceptors=createServerCredentialsWithInterceptors;