var ber=require("asn1-ber").Ber,smartbuffer=require("smart-buffer"),dgram=require("dgram"),net=require("net"),events=require("events"),util=require("util"),crypto=require("crypto"),mibparser=require("./lib/mib"),DEBUG=!1,MIN_SIGNED_INT32=-2147483648,MAX_SIGNED_INT32=2147483647,MIN_UNSIGNED_INT32=0,MAX_UNSIGNED_INT32=4294967295;function debug(e){DEBUG&&console.debug(e)}function _expandConstantObject(e){var t=[];for(var r in e)t.push(r);for(var i=0;i<t.length;i++)e[e[t[i]]]=parseInt(t[i])}var ErrorStatus={0:"NoError",1:"TooBig",2:"NoSuchName",3:"BadValue",4:"ReadOnly",5:"GeneralError",6:"NoAccess",7:"WrongType",8:"WrongLength",9:"WrongEncoding",10:"WrongValue",11:"NoCreation",12:"InconsistentValue",13:"ResourceUnavailable",14:"CommitFailed",15:"UndoFailed",16:"AuthorizationError",17:"NotWritable",18:"InconsistentName"};_expandConstantObject(ErrorStatus);var ObjectType={1:"Boolean",2:"Integer",3:"BitString",4:"OctetString",5:"Null",6:"OID",64:"IpAddress",65:"Counter",66:"Gauge",67:"TimeTicks",68:"Opaque",70:"Counter64",128:"NoSuchObject",129:"NoSuchInstance",130:"EndOfMibView"};_expandConstantObject(ObjectType),ObjectType.INTEGER=ObjectType.Integer,ObjectType["OCTET STRING"]=ObjectType.OctetString,ObjectType["OBJECT IDENTIFIER"]=ObjectType.OID,ObjectType.Integer32=ObjectType.Integer,ObjectType.Counter32=ObjectType.Counter,ObjectType.Gauge32=ObjectType.Gauge,ObjectType.Unsigned32=ObjectType.Gauge32;var PduType={160:"GetRequest",161:"GetNextRequest",162:"GetResponse",163:"SetRequest",164:"Trap",165:"GetBulkRequest",166:"InformRequest",167:"TrapV2",168:"Report"};_expandConstantObject(PduType);var TrapType={0:"ColdStart",1:"WarmStart",2:"LinkDown",3:"LinkUp",4:"AuthenticationFailure",5:"EgpNeighborLoss",6:"EnterpriseSpecific"};_expandConstantObject(TrapType);var SecurityLevel={1:"noAuthNoPriv",2:"authNoPriv",3:"authPriv"};_expandConstantObject(SecurityLevel);var AuthProtocols={1:"none",2:"md5",3:"sha",4:"sha224",5:"sha256",6:"sha384",7:"sha512"};_expandConstantObject(AuthProtocols);var PrivProtocols={1:"none",2:"des",4:"aes",6:"aes256b",8:"aes256r"};_expandConstantObject(PrivProtocols);var UsmStatsBase="1.3.6.1.6.3.15.1.1",UsmStats={1:"Unsupported Security Level",2:"Not In Time Window",3:"Unknown User Name",4:"Unknown Engine ID",5:"Wrong Digest (incorrect password, community or key)",6:"Decryption Error"};_expandConstantObject(UsmStats);var MibProviderType={1:"Scalar",2:"Table"};_expandConstantObject(MibProviderType);var Version1=0,Version2c=1,Version3=3,Version={1:Version1,"2c":Version2c,3:Version3},AgentXPduType={1:"Open",2:"Close",3:"Register",4:"Unregister",5:"Get",6:"GetNext",7:"GetBulk",8:"TestSet",9:"CommitSet",10:"UndoSet",11:"CleanupSet",12:"Notify",13:"Ping",14:"IndexAllocate",15:"IndexDeallocate",16:"AddAgentCaps",17:"RemoveAgentCaps",18:"Response"};_expandConstantObject(AgentXPduType);var AccessControlModelType={0:"None",1:"Simple"};_expandConstantObject(AccessControlModelType);var AccessLevel={0:"None",1:"ReadOnly",2:"ReadWrite"};_expandConstantObject(AccessLevel);var MaxAccess={0:"not-accessible",1:"accessible-for-notify",2:"read-only",3:"read-write",4:"read-create"};_expandConstantObject(MaxAccess);var AccessToMaxAccess={"not-accessible":"not-accessible","read-only":"read-only","read-write":"read-write","write-only":"read-write"},RowStatus={1:"active",2:"notInService",3:"notReady",4:"createAndGo",5:"createAndWait",6:"destroy"};_expandConstantObject(RowStatus);var ResponseInvalidCode={1:"EIp4AddressSize",2:"EUnknownObjectType",3:"EUnknownPduType",4:"ECouldNotDecrypt",5:"EAuthFailure",6:"EReqResOidNoMatch",8:"EOutOfOrder",9:"EVersionNoMatch",10:"ECommunityNoMatch",11:"EUnexpectedReport",12:"EResponseNotHandled",13:"EUnexpectedResponse"};function ResponseInvalidError(e,t,r){this.name="ResponseInvalidError",this.message=e,this.code=t,this.info=r,Error.captureStackTrace(this,ResponseInvalidError)}function RequestInvalidError(e){this.name="RequestInvalidError",this.message=e,Error.captureStackTrace(this,RequestInvalidError)}function RequestFailedError(e,t){this.name="RequestFailedError",this.message=e,this.status=t,Error.captureStackTrace(this,RequestFailedError)}function RequestTimedOutError(e){this.name="RequestTimedOutError",this.message=e,Error.captureStackTrace(this,RequestTimedOutError)}function ProcessingError(e,t,r,i){this.name="ProcessingError",this.message=e,this.error=t,this.rinfo=r,this.buffer=i,Error.captureStackTrace(this,ProcessingError)}function isVarbindError(e){return!(e.type!=ObjectType.NoSuchObject&&e.type!=ObjectType.NoSuchInstance&&e.type!=ObjectType.EndOfMibView)}function varbindError(e){return(ObjectType[e.type]||"NotAnError")+": "+e.oid}function oidFollowsOid(e,t){var r={str:e,len:e.length,idx:0},i={str:t,len:t.length,idx:0},n=".".charCodeAt(0);function s(e){var t=0;if(e.idx>=e.len)return null;for(;e.idx<e.len;){var r=e.str.charCodeAt(e.idx++);if(r==n)return t;t=(t?10*t:t)+(r-48)}return t}for(;;){var o=s(r),a=s(i);if(null===o)return!0;if(null===a)return!0;if(a>o)return!0;if(a<o)return!1}}function oidInSubtree(e,t){var r=e.split("."),i=t.split(".");if(r.length>i.length)return!1;for(var n=0;n<r.length;n++)if(i[n]!=r[n])return!1;return!0}function readInt32(e){var t=e.readInt();if(!Number.isInteger(t))throw new TypeError("Value read as integer "+t+" is not an integer");if(t<MIN_SIGNED_INT32||t>MAX_SIGNED_INT32)throw new RangeError("Read integer "+t+" is outside the signed 32-bit range");return t}function readUint32(e){var t=e.readInt();if(!Number.isInteger(t))throw new TypeError("Value read as integer "+t+" is not an integer");if((t>>>=0)<MIN_UNSIGNED_INT32||t>MAX_UNSIGNED_INT32)throw new RangeError("Read integer "+t+" is outside the unsigned 32-bit range");return t}function readUint64(e){return e.readString(ObjectType.Counter64,!0)}function readIpAddress(e){var t=e.readString(ObjectType.IpAddress,!0);if(4!=t.length)throw new ResponseInvalidError("Length '"+t.length+"' of IP address '"+t.toString("hex")+"' is not 4",ResponseInvalidCode.EIp4AddressSize);return t[0]+"."+t[1]+"."+t[2]+"."+t[3]}function readVarbindValue(e,t){var r;if(t==ObjectType.Boolean)r=e.readBoolean();else if(t==ObjectType.Integer)r=readInt32(e);else if(t==ObjectType.BitString)r=e.readBitString();else if(t==ObjectType.OctetString)r=e.readString(null,!0);else if(t==ObjectType.Null)e.readByte(),e.readByte(),r=null;else if(t==ObjectType.OID)r=e.readOID();else if(t==ObjectType.IpAddress)r=readIpAddress(e);else if(t==ObjectType.Counter)r=readUint32(e);else if(t==ObjectType.Gauge)r=readUint32(e);else if(t==ObjectType.TimeTicks)r=readUint32(e);else if(t==ObjectType.Opaque)r=e.readString(ObjectType.Opaque,!0);else if(t==ObjectType.Counter64)r=readUint64(e);else if(t==ObjectType.NoSuchObject)e.readByte(),e.readByte(),r=null;else if(t==ObjectType.NoSuchInstance)e.readByte(),e.readByte(),r=null;else{if(t!=ObjectType.EndOfMibView)throw new ResponseInvalidError("Unknown type '"+t+"' in response",ResponseInvalidCode.EUnknownObjectType);e.readByte(),e.readByte(),r=null}return r}function readVarbinds(e,t){for(e.readSequence();e.readSequence(),e.peek()==ObjectType.OID;){var r=e.readOID(),i=e.peek();if(null==i)break;var n=readVarbindValue(e,i);t.push({oid:r,type:i,value:n})}}function writeInt32(e,t,r){if(!Number.isInteger(r))throw new TypeError("Value to write as integer "+r+" is not an integer");if(r<MIN_SIGNED_INT32||r>MAX_SIGNED_INT32)throw new RangeError("Integer to write "+r+" is outside the signed 32-bit range");e.writeInt(r,t)}function writeUint32(e,t,r){if(!Number.isInteger(r))throw new TypeError("Value to write as integer "+r+" is not an integer");if(r<MIN_UNSIGNED_INT32||r>MAX_UNSIGNED_INT32)throw new RangeError("Integer to write "+r+" is outside the unsigned 32-bit range");e.writeInt(r,t)}function writeUint64(e,t){e.writeBuffer(t,ObjectType.Counter64)}function writeVarbinds(e,t){e.startSequence();for(var r=0;r<t.length;r++){if(e.startSequence(),e.writeOID(t[r].oid),t[r].type&&t[r].hasOwnProperty("value")){var i=t[r].type,n=t[r].value;switch(i){case ObjectType.Boolean:e.writeBoolean(!!n);break;case ObjectType.Integer:writeInt32(e,ObjectType.Integer,n);break;case ObjectType.OctetString:"string"==typeof n?e.writeString(n):e.writeBuffer(n,ObjectType.OctetString);break;case ObjectType.Null:e.writeNull();break;case ObjectType.OID:e.writeOID(n);break;case ObjectType.IpAddress:var s=n.split(".");if(4!=s.length)throw new RequestInvalidError("Invalid IP address '"+n+"'");e.writeBuffer(Buffer.from(s),64);break;case ObjectType.Counter:writeUint32(e,ObjectType.Counter,n);break;case ObjectType.Gauge:writeUint32(e,ObjectType.Gauge,n);break;case ObjectType.TimeTicks:writeUint32(e,ObjectType.TimeTicks,n);break;case ObjectType.Opaque:e.writeBuffer(n,ObjectType.Opaque);break;case ObjectType.Counter64:writeUint64(e,n);break;case ObjectType.NoSuchObject:case ObjectType.NoSuchInstance:case ObjectType.EndOfMibView:e.writeByte(i),e.writeByte(0);break;default:throw new RequestInvalidError("Unknown type '"+i+"' in request")}}else e.writeNull();e.endSequence()}e.endSequence()}_expandConstantObject(ResponseInvalidCode),util.inherits(ResponseInvalidError,Error),util.inherits(RequestInvalidError,Error),util.inherits(RequestFailedError,Error),util.inherits(RequestTimedOutError,Error),util.inherits(ProcessingError,Error);var SimplePdu=function(){};SimplePdu.prototype.toBuffer=function(e){e.startSequence(this.type),writeInt32(e,ObjectType.Integer,this.id),writeInt32(e,ObjectType.Integer,this.type==PduType.GetBulkRequest&&this.options.nonRepeaters||0),writeInt32(e,ObjectType.Integer,this.type==PduType.GetBulkRequest&&this.options.maxRepetitions||0),writeVarbinds(e,this.varbinds),e.endSequence()},SimplePdu.prototype.initializeFromVariables=function(e,t,r){this.id=e,this.varbinds=t,this.options=r||{},this.contextName=r&&r.context?r.context:""},SimplePdu.prototype.initializeFromBuffer=function(e){this.type=e.peek(),e.readSequence(),this.id=readInt32(e),this.nonRepeaters=readInt32(e),this.maxRepetitions=readInt32(e),this.varbinds=[],readVarbinds(e,this.varbinds)},SimplePdu.prototype.getResponsePduForRequest=function(){var e=GetResponsePdu.createFromVariables(this.id,[],{});return this.contextEngineID&&(e.contextEngineID=this.contextEngineID,e.contextName=this.contextName),e},SimplePdu.createFromVariables=function(e,t,r,i){var n=new e(t,r,i);return n.id=t,n.varbinds=r,n.options=i||{},n.contextName=i&&i.context?i.context:"",n};var GetBulkRequestPdu=function(){this.type=PduType.GetBulkRequest,GetBulkRequestPdu.super_.apply(this,arguments)};util.inherits(GetBulkRequestPdu,SimplePdu),GetBulkRequestPdu.createFromBuffer=function(e){var t=new GetBulkRequestPdu;return t.initializeFromBuffer(e),t};var GetNextRequestPdu=function(){this.type=PduType.GetNextRequest,GetNextRequestPdu.super_.apply(this,arguments)};util.inherits(GetNextRequestPdu,SimplePdu),GetNextRequestPdu.createFromBuffer=function(e){var t=new GetNextRequestPdu;return t.initializeFromBuffer(e),t};var GetRequestPdu=function(){this.type=PduType.GetRequest,GetRequestPdu.super_.apply(this,arguments)};util.inherits(GetRequestPdu,SimplePdu),GetRequestPdu.createFromBuffer=function(e){var t=new GetRequestPdu;return t.initializeFromBuffer(e),t},GetRequestPdu.createFromVariables=function(e,t,r){var i=new GetRequestPdu;return i.initializeFromVariables(e,t,r),i};var InformRequestPdu=function(){this.type=PduType.InformRequest,InformRequestPdu.super_.apply(this,arguments)};util.inherits(InformRequestPdu,SimplePdu),InformRequestPdu.createFromBuffer=function(e){var t=new InformRequestPdu;return t.initializeFromBuffer(e),t};var SetRequestPdu=function(){this.type=PduType.SetRequest,SetRequestPdu.super_.apply(this,arguments)};util.inherits(SetRequestPdu,SimplePdu),SetRequestPdu.createFromBuffer=function(e){var t=new SetRequestPdu;return t.initializeFromBuffer(e),t};var TrapPdu=function(){this.type=PduType.Trap};TrapPdu.prototype.toBuffer=function(e){e.startSequence(this.type),e.writeOID(this.enterprise),e.writeBuffer(Buffer.from(this.agentAddr.split(".")),ObjectType.IpAddress),writeInt32(e,ObjectType.Integer,this.generic),writeInt32(e,ObjectType.Integer,this.specific),writeUint32(e,ObjectType.TimeTicks,this.upTime||Math.floor(100*process.uptime())),writeVarbinds(e,this.varbinds),e.endSequence()},TrapPdu.createFromBuffer=function(e){var t=new TrapPdu;return e.readSequence(),t.enterprise=e.readOID(),t.agentAddr=readIpAddress(e),t.generic=readInt32(e),t.specific=readInt32(e),t.upTime=readUint32(e),t.varbinds=[],readVarbinds(e,t.varbinds),t},TrapPdu.createFromVariables=function(e,t,r){var i=new TrapPdu;return i.agentAddr=r.agentAddr||"127.0.0.1",i.upTime=r.upTime,"string"==typeof e?(i.generic=TrapType.EnterpriseSpecific,i.specific=parseInt(e.match(/\.(\d+)$/)[1]),i.enterprise=e.replace(/\.(\d+)$/,"")):(i.generic=e,i.specific=0,i.enterprise="1.3.6.1.4.1"),i.varbinds=t,i};var TrapV2Pdu=function(){this.type=PduType.TrapV2,TrapV2Pdu.super_.apply(this,arguments)};util.inherits(TrapV2Pdu,SimplePdu),TrapV2Pdu.createFromBuffer=function(e){var t=new TrapV2Pdu;return t.initializeFromBuffer(e),t},TrapV2Pdu.createFromVariables=function(e,t,r){var i=new TrapV2Pdu;return i.initializeFromVariables(e,t,r),i};var SimpleResponsePdu=function(){};SimpleResponsePdu.prototype.toBuffer=function(e){e.startSequence(this.type),writeInt32(e,ObjectType.Integer,this.id),writeInt32(e,ObjectType.Integer,this.errorStatus||0),writeInt32(e,ObjectType.Integer,this.errorIndex||0),writeVarbinds(e,this.varbinds),e.endSequence()},SimpleResponsePdu.prototype.initializeFromBuffer=function(e){e.readSequence(this.type),this.id=readInt32(e),this.errorStatus=readInt32(e),this.errorIndex=readInt32(e),this.varbinds=[],readVarbinds(e,this.varbinds)},SimpleResponsePdu.prototype.initializeFromVariables=function(e,t,r){this.id=e,this.varbinds=t,this.options=r||{}};var GetResponsePdu=function(){this.type=PduType.GetResponse,GetResponsePdu.super_.apply(this,arguments)};util.inherits(GetResponsePdu,SimpleResponsePdu),GetResponsePdu.createFromBuffer=function(e){var t=new GetResponsePdu;return t.initializeFromBuffer(e),t},GetResponsePdu.createFromVariables=function(e,t,r){var i=new GetResponsePdu;return i.initializeFromVariables(e,t,r),i};var ReportPdu=function(){this.type=PduType.Report,ReportPdu.super_.apply(this,arguments)};util.inherits(ReportPdu,SimpleResponsePdu),ReportPdu.createFromBuffer=function(e){var t=new ReportPdu;return t.initializeFromBuffer(e),t},ReportPdu.createFromVariables=function(e,t,r){var i=new ReportPdu;return i.initializeFromVariables(e,t,r),i};var readPdu=function(e,t){var r,i,n;t&&(i=(e=new ber.Reader(e.readString(ber.Sequence|ber.Constructor,!0))).readString(ber.OctetString,!0),n=e.readString());var s=e.peek();if(s==PduType.GetResponse)r=GetResponsePdu.createFromBuffer(e);else if(s==PduType.Report)r=ReportPdu.createFromBuffer(e);else if(s==PduType.Trap)r=TrapPdu.createFromBuffer(e);else if(s==PduType.TrapV2)r=TrapV2Pdu.createFromBuffer(e);else if(s==PduType.InformRequest)r=InformRequestPdu.createFromBuffer(e);else if(s==PduType.GetRequest)r=GetRequestPdu.createFromBuffer(e);else if(s==PduType.SetRequest)r=SetRequestPdu.createFromBuffer(e);else if(s==PduType.GetNextRequest)r=GetNextRequestPdu.createFromBuffer(e);else{if(s!=PduType.GetBulkRequest)throw new ResponseInvalidError("Unknown PDU type '"+s+"' in response",ResponseInvalidCode.EUnknownPduType);r=GetBulkRequestPdu.createFromBuffer(e)}return t&&(r.contextEngineID=i,r.contextName=n),r.scoped=t,r},createDiscoveryPdu=function(e){return GetRequestPdu.createFromVariables(_generateId(),[],{context:e})},Authentication={HMAC_BUFFER_SIZE:1048576,algorithms:{}};Authentication.algorithms[AuthProtocols.md5]={KEY_LENGTH:16,AUTHENTICATION_CODE_LENGTH:12,CRYPTO_ALGORITHM:"md5"},Authentication.algorithms[AuthProtocols.sha]={KEY_LENGTH:20,AUTHENTICATION_CODE_LENGTH:12,CRYPTO_ALGORITHM:"sha1"},Authentication.algorithms[AuthProtocols.sha224]={KEY_LENGTH:28,AUTHENTICATION_CODE_LENGTH:16,CRYPTO_ALGORITHM:"sha224"},Authentication.algorithms[AuthProtocols.sha256]={KEY_LENGTH:32,AUTHENTICATION_CODE_LENGTH:24,CRYPTO_ALGORITHM:"sha256"},Authentication.algorithms[AuthProtocols.sha384]={KEY_LENGTH:48,AUTHENTICATION_CODE_LENGTH:32,CRYPTO_ALGORITHM:"sha384"},Authentication.algorithms[AuthProtocols.sha512]={KEY_LENGTH:64,AUTHENTICATION_CODE_LENGTH:48,CRYPTO_ALGORITHM:"sha512"},Authentication.authToKeyCache={},Authentication.computeCacheKey=function(e,t,r){return e+t+r.toString("base64")},Authentication.passwordToKey=function(e,t,r){var i,n,s,o,a=Authentication.algorithms[e].CRYPTO_ALGORITHM,u=Authentication.computeCacheKey(e,t,r);return void 0!==Authentication.authToKeyCache[u]?Authentication.authToKeyCache[u]:(o=Buffer.alloc(Authentication.HMAC_BUFFER_SIZE,t),(i=crypto.createHash(a)).update(o),n=i.digest(),(i=crypto.createHash(a)).update(n),i.update(r),i.update(n),s=i.digest(),Authentication.authToKeyCache[u]=s,s)},Authentication.getParametersLength=function(e){return Authentication.algorithms[e].AUTHENTICATION_CODE_LENGTH},Authentication.writeParameters=function(e,t,r,i,n){Authentication.calculateDigest(e,t,r,i).copy(n)},Authentication.isAuthentic=function(e,t,r,i,n){var s,o;return n.length===Authentication.algorithms[t].AUTHENTICATION_CODE_LENGTH&&(s=Buffer.from(n),n.fill(0),o=Authentication.calculateDigest(e,t,r,i),s.copy(n),o.equals(n))},Authentication.calculateDigest=function(e,t,r,i){var n=Authentication.passwordToKey(t,r,i),s=Authentication.algorithms[t].CRYPTO_ALGORITHM,o=crypto.createHmac(s,n);return o.update(e),o.digest().subarray(0,Authentication.algorithms[t].AUTHENTICATION_CODE_LENGTH)};var Encryption={encryptPdu:function(e,t,r,i,n){return(0,Encryption.algorithms[e].encryptPdu)(t,e,r,i,n)},decryptPdu:function(e,t,r,i,n,s){return(0,Encryption.algorithms[e].decryptPdu)(t,e,r,i,n,s)},debugEncrypt:function(e,t,r,i){debug("Key: "+e.toString("hex")),debug("IV:  "+t.toString("hex")),debug("Plain:     "+r.toString("hex")),debug("Encrypted: "+i.toString("hex"))},debugDecrypt:function(e,t,r,i){debug("Key: "+e.toString("hex")),debug("IV:  "+t.toString("hex")),debug("Encrypted: "+r.toString("hex")),debug("Plain:     "+i.toString("hex"))},generateLocalizedKey:function(e,t,r,i){var n,s;return n=Authentication.passwordToKey(t,r,i),s=Buffer.alloc(e.KEY_LENGTH),n.copy(s,0,0,e.KEY_LENGTH),s},generateLocalizedKeyBlumenthal:function(e,t,r,i){let n,s,o,a,u,d,c;n=Authentication.algorithms[t].KEY_LENGTH,a=Math.ceil(e.KEY_LENGTH/n),o=Buffer.alloc(e.KEY_LENGTH),s=Authentication.passwordToKey(t,r,i),d=s;for(let e=0;e<a;e++)d.copy(o,e*n,0,n),e<a-1&&(c=crypto.createHash(Authentication.algorithms[t].CRYPTO_ALGORITHM),u=Buffer.alloc((e+1)*n),o.copy(u,e*n,0,(e+1)*n),c.update(u),d=c.digest());return o},generateLocalizedKeyReeder:function(e,t,r,i){let n,s,o,a,u;n=Authentication.algorithms[t].KEY_LENGTH,a=Math.ceil(e.KEY_LENGTH/n),o=Buffer.alloc(e.KEY_LENGTH),u=r;for(let e=0;e<a;e++)s=Authentication.passwordToKey(t,u,i),s.copy(o,e*n,0,n),u=s;return o},encryptPduDes:function(e,t,r,i,n){var s,o,a,u,d,c,p,l,h,g,y=Encryption.algorithms[PrivProtocols.des];for(Encryption.generateLocalizedKey(y,i,r,n.engineID),s=Authentication.passwordToKey(i,r,n.engineID),o=Buffer.alloc(y.KEY_LENGTH),s.copy(o,0,0,y.KEY_LENGTH),a=Buffer.alloc(y.BLOCK_LENGTH),s.copy(a,0,y.KEY_LENGTH,y.KEY_LENGTH+y.BLOCK_LENGTH),(u=Buffer.alloc(y.BLOCK_LENGTH)).fill("00000001",0,4,"hex"),u.fill(crypto.randomBytes(4),4,8),d=Buffer.alloc(y.BLOCK_LENGTH),c=0;c<d.length;c++)d[c]=a[c]^u[c];return e.length%y.BLOCK_LENGTH==0?l=e:(p=y.BLOCK_LENGTH*(Math.floor(e.length/y.BLOCK_LENGTH)+1),l=Buffer.alloc(p),e.copy(l,0,0,e.length)),h=(g=crypto.createCipheriv(y.CRYPTO_ALGORITHM,o,d)).update(l),{encryptedPdu:h=Buffer.concat([h,g.final()]),msgPrivacyParameters:u}},decryptPduDes:function(e,t,r,i,n,s){var o,a,u,d,c,p,l,h,g=Encryption.algorithms[PrivProtocols.des];for(o=Authentication.passwordToKey(n,i,s.engineID),a=Buffer.alloc(g.KEY_LENGTH),o.copy(a,0,0,g.KEY_LENGTH),u=Buffer.alloc(g.BLOCK_LENGTH),o.copy(u,0,g.KEY_LENGTH,g.KEY_LENGTH+g.BLOCK_LENGTH),d=r,c=Buffer.alloc(g.BLOCK_LENGTH),p=0;p<c.length;p++)c[p]=u[p]^d[p];return(h=crypto.createDecipheriv(g.CRYPTO_ALGORITHM,a,c)).setAutoPadding(!1),l=h.update(e),l=Buffer.concat([l,h.final()])},generateIvAes:function(e,t,r,i){var n,s,o;return n=Buffer.alloc(e.BLOCK_LENGTH),(s=Buffer.alloc(4)).writeUInt32BE(t),(o=Buffer.alloc(4)).writeUInt32BE(r),s.copy(n,0,0,4),o.copy(n,4,0,4),i.copy(n,8,0,8),n},encryptPduAes:function(e,t,r,i,n){var s,o,a,u,d,c=Encryption.algorithms[t];return s=(0,c.localizationAlgorithm)(c,i,r,n.engineID),o=Buffer.alloc(8).fill(crypto.randomBytes(8),0,8),a=Encryption.generateIvAes(c,n.engineBoots,n.engineTime,o),d=(u=crypto.createCipheriv(c.CRYPTO_ALGORITHM,s,a)).update(e),{encryptedPdu:d=Buffer.concat([d,u.final()]),msgPrivacyParameters:o}},decryptPduAes:function(e,t,r,i,n,s){var o,a,u,d,c=Encryption.algorithms[t];return o=(0,c.localizationAlgorithm)(c,n,i,s.engineID),a=Encryption.generateIvAes(c,s.engineBoots,s.engineTime,r),d=(u=crypto.createDecipheriv(c.CRYPTO_ALGORITHM,o,a)).update(e),d=Buffer.concat([d,u.final()])},algorithms:{}};Encryption.algorithms[PrivProtocols.des]={CRYPTO_ALGORITHM:"des-cbc",KEY_LENGTH:8,BLOCK_LENGTH:8,encryptPdu:Encryption.encryptPduDes,decryptPdu:Encryption.decryptPduDes,localizationAlgorithm:Encryption.generateLocalizedKey},Encryption.algorithms[PrivProtocols.aes]={CRYPTO_ALGORITHM:"aes-128-cfb",KEY_LENGTH:16,BLOCK_LENGTH:16,encryptPdu:Encryption.encryptPduAes,decryptPdu:Encryption.decryptPduAes,localizationAlgorithm:Encryption.generateLocalizedKey},Encryption.algorithms[PrivProtocols.aes256b]={CRYPTO_ALGORITHM:"aes-256-cfb",KEY_LENGTH:32,BLOCK_LENGTH:16,encryptPdu:Encryption.encryptPduAes,decryptPdu:Encryption.decryptPduAes,localizationAlgorithm:Encryption.generateLocalizedKeyBlumenthal},Encryption.algorithms[PrivProtocols.aes256r]={CRYPTO_ALGORITHM:"aes-256-cfb",KEY_LENGTH:32,BLOCK_LENGTH:16,encryptPdu:Encryption.encryptPduAes,decryptPdu:Encryption.decryptPduAes,localizationAlgorithm:Encryption.generateLocalizedKeyReeder};var Message=function(){};Message.prototype.getReqId=function(){return this.version==Version3?this.msgGlobalData.msgID:this.pdu.id},Message.prototype.toBuffer=function(){return this.version==Version3?this.toBufferV3():this.toBufferCommunity()},Message.prototype.toBufferCommunity=function(){if(this.buffer)return this.buffer;var e=new ber.Writer;return e.startSequence(),writeInt32(e,ObjectType.Integer,this.version),e.writeString(this.community),this.pdu.toBuffer(e),e.endSequence(),this.buffer=e.buffer,this.buffer},Message.prototype.toBufferV3=function(){var e;if(this.buffer)return this.buffer;var t=new ber.Writer;t.startSequence();var r=this.pdu.contextEngineID?this.pdu.contextEngineID:this.msgSecurityParameters.msgAuthoritativeEngineID;if(0==r.length?t.writeString(""):t.writeBuffer(r,ber.OctetString),t.writeString(this.pdu.contextName),this.pdu.toBuffer(t),t.endSequence(),this.hasPrivacy()){var i={engineID:this.msgSecurityParameters.msgAuthoritativeEngineID,engineBoots:this.msgSecurityParameters.msgAuthoritativeEngineBoots,engineTime:this.msgSecurityParameters.msgAuthoritativeEngineTime};e=Encryption.encryptPdu(this.user.privProtocol,t.buffer,this.user.privKey,this.user.authProtocol,i)}var n=new ber.Writer;n.startSequence(),writeInt32(n,ObjectType.Integer,this.version),n.startSequence(),writeInt32(n,ObjectType.Integer,this.msgGlobalData.msgID),writeInt32(n,ObjectType.Integer,this.msgGlobalData.msgMaxSize),n.writeByte(ber.OctetString),n.writeByte(1),n.writeByte(this.msgGlobalData.msgFlags),writeInt32(n,ObjectType.Integer,this.msgGlobalData.msgSecurityModel),n.endSequence(),n.startSequence(ber.OctetString),n.startSequence(),0==this.msgSecurityParameters.msgAuthoritativeEngineID.length?n.writeString(""):n.writeBuffer(this.msgSecurityParameters.msgAuthoritativeEngineID,ber.OctetString),writeInt32(n,ObjectType.Integer,this.msgSecurityParameters.msgAuthoritativeEngineBoots),writeInt32(n,ObjectType.Integer,this.msgSecurityParameters.msgAuthoritativeEngineTime),n.writeString(this.msgSecurityParameters.msgUserName);var s="";if(this.hasAuthentication()){var o=Authentication.getParametersLength(this.user.authProtocol);s=Buffer.alloc(o),n.writeBuffer(s,ber.OctetString)}else n.writeString("");var a=n._offset-s.length;return this.hasPrivacy()?n.writeBuffer(e.msgPrivacyParameters,ber.OctetString):n.writeString(""),a-=n._offset,n.endSequence(),n.endSequence(),a+=n._offset,this.hasPrivacy()?n.writeBuffer(e.encryptedPdu,ber.OctetString):n.writeBuffer(t.buffer),a-=n._offset,n.endSequence(),a+=n._offset,this.buffer=n.buffer,this.hasAuthentication()&&(s=this.buffer.subarray(a,a+s.length),Authentication.writeParameters(this.buffer,this.user.authProtocol,this.user.authKey,this.msgSecurityParameters.msgAuthoritativeEngineID,s)),this.buffer},Message.prototype.processIncomingSecurity=function(e,t){return!(this.hasPrivacy()&&!this.decryptPdu(e,t))&&(!(this.hasAuthentication()&&!this.isAuthenticationDisabled())||this.checkAuthentication(e,t))},Message.prototype.decryptPdu=function(e,t){var r,i;try{var n={engineID:this.msgSecurityParameters.msgAuthoritativeEngineID,engineBoots:this.msgSecurityParameters.msgAuthoritativeEngineBoots,engineTime:this.msgSecurityParameters.msgAuthoritativeEngineTime};return r=Encryption.decryptPdu(e.privProtocol,this.encryptedPdu,this.msgSecurityParameters.msgPrivacyParameters,e.privKey,e.authProtocol,n),i=new ber.Reader(r),this.pdu=readPdu(i,!0),!0}catch(e){return t(new ResponseInvalidError("Failed to decrypt PDU: "+e,ResponseInvalidCode.ECouldNotDecrypt)),!1}},Message.prototype.checkAuthentication=function(e,t){return!!Authentication.isAuthentic(this.buffer,e.authProtocol,e.authKey,this.msgSecurityParameters.msgAuthoritativeEngineID,this.msgSecurityParameters.msgAuthenticationParameters)||(t(new ResponseInvalidError("Authentication digest "+this.msgSecurityParameters.msgAuthenticationParameters.toString("hex")+" received in message does not match digest "+Authentication.calculateDigest(this.buffer,e.authProtocol,e.authKey,this.msgSecurityParameters.msgAuthoritativeEngineID).toString("hex")+" calculated for message",ResponseInvalidCode.EAuthFailure,{user:e})),!1)},Message.prototype.setMsgFlags=function(e,t){this.msgGlobalData&&void 0!==this.msgGlobalData&&null!==this.msgGlobalData&&(this.msgGlobalData.msgFlags=t?this.msgGlobalData.msgFlags|2**e:this.msgGlobalData.msgFlags&255-2**e)},Message.prototype.hasAuthentication=function(){return this.msgGlobalData&&this.msgGlobalData.msgFlags&&1&this.msgGlobalData.msgFlags},Message.prototype.setAuthentication=function(e){this.setMsgFlags(0,e)},Message.prototype.hasPrivacy=function(){return this.msgGlobalData&&this.msgGlobalData.msgFlags&&2&this.msgGlobalData.msgFlags},Message.prototype.setPrivacy=function(e){this.setMsgFlags(1,e)},Message.prototype.isReportable=function(){return this.msgGlobalData&&this.msgGlobalData.msgFlags&&4&this.msgGlobalData.msgFlags},Message.prototype.setReportable=function(e){this.setMsgFlags(2,e)},Message.prototype.isAuthenticationDisabled=function(){return this.disableAuthentication},Message.prototype.hasAuthoritativeEngineID=function(){return this.msgSecurityParameters&&this.msgSecurityParameters.msgAuthoritativeEngineID&&""!=this.msgSecurityParameters.msgAuthoritativeEngineID},Message.prototype.createReportResponseMessage=function(e,t){var r={name:"",level:SecurityLevel.noAuthNoPriv},i={msgAuthoritativeEngineID:e.engineID,msgAuthoritativeEngineBoots:e.engineBoots,msgAuthoritativeEngineTime:e.engineTime,msgUserName:r.name,msgAuthenticationParameters:"",msgPrivacyParameters:""},n=ReportPdu.createFromVariables(this.pdu.id,[],{});n.contextName=t;var s=Message.createRequestV3(r,i,n);return s.msgGlobalData.msgID=this.msgGlobalData.msgID,s},Message.prototype.createResponseForRequest=function(e){return this.version==Version3?this.createV3ResponseFromRequest(e):this.createCommunityResponseFromRequest(e)},Message.prototype.createCommunityResponseFromRequest=function(e){return Message.createCommunity(this.version,this.community,e)},Message.prototype.createV3ResponseFromRequest=function(e){var t={name:this.user.name,level:this.user.level,authProtocol:this.user.authProtocol,authKey:this.user.authKey,privProtocol:this.user.privProtocol,privKey:this.user.privKey},r={msgAuthoritativeEngineID:this.msgSecurityParameters.msgAuthoritativeEngineID,msgAuthoritativeEngineBoots:this.msgSecurityParameters.msgAuthoritativeEngineBoots,msgAuthoritativeEngineTime:this.msgSecurityParameters.msgAuthoritativeEngineTime,msgUserName:this.msgSecurityParameters.msgUserName,msgAuthenticationParameters:"",msgPrivacyParameters:""},i={msgID:this.msgGlobalData.msgID,msgMaxSize:65507,msgFlags:251&this.msgGlobalData.msgFlags,msgSecurityModel:3};return Message.createV3(t,i,r,e)},Message.createCommunity=function(e,t,r){var i=new Message;return i.version=e,i.community=t,i.pdu=r,i},Message.createRequestV3=function(e,t,r){var i=e.level==SecurityLevel.authNoPriv||e.level==SecurityLevel.authPriv?1:0,n=e.level==SecurityLevel.authPriv?1:0,s=r.type==PduType.GetResponse||r.type==PduType.TrapV2?0:1,o={msgID:_generateId(),msgMaxSize:65507,msgFlags:4*s|2*n|1*i,msgSecurityModel:3};return Message.createV3(e,o,t,r)},Message.createV3=function(e,t,r,i){var n=new Message;return n.version=3,n.user=e,n.msgGlobalData=t,n.msgSecurityParameters={msgAuthoritativeEngineID:r.msgAuthoritativeEngineID||Buffer.from(""),msgAuthoritativeEngineBoots:r.msgAuthoritativeEngineBoots||0,msgAuthoritativeEngineTime:r.msgAuthoritativeEngineTime||0,msgUserName:e.name||"",msgAuthenticationParameters:"",msgPrivacyParameters:""},n.pdu=i,n},Message.createDiscoveryV3=function(e){var t={msgAuthoritativeEngineID:Buffer.from(""),msgAuthoritativeEngineBoots:0,msgAuthoritativeEngineTime:0},r={name:"",level:SecurityLevel.noAuthNoPriv};return Message.createRequestV3(r,t,e)},Message.createFromBuffer=function(e,t){var r=new ber.Reader(e),i=new Message;if(r.readSequence(),i.version=readInt32(r),3!=i.version)i.community=r.readString(),i.pdu=readPdu(r,!1);else{i.msgGlobalData={},r.readSequence(),i.msgGlobalData.msgID=readInt32(r),i.msgGlobalData.msgMaxSize=readInt32(r),i.msgGlobalData.msgFlags=r.readString(ber.OctetString,!0)[0],i.msgGlobalData.msgSecurityModel=readInt32(r),i.msgSecurityParameters={};var n=new ber.Reader(r.readString(ber.OctetString,!0));n.readSequence(),i.msgSecurityParameters.msgAuthoritativeEngineID=n.readString(ber.OctetString,!0),i.msgSecurityParameters.msgAuthoritativeEngineBoots=readInt32(n),i.msgSecurityParameters.msgAuthoritativeEngineTime=readInt32(n),i.msgSecurityParameters.msgUserName=n.readString(),i.msgSecurityParameters.msgAuthenticationParameters=n.readString(ber.OctetString,!0),i.msgSecurityParameters.msgPrivacyParameters=Buffer.from(n.readString(ber.OctetString,!0)),i.hasPrivacy()?(i.encryptedPdu=r.readString(ber.OctetString,!0),i.pdu=null):i.pdu=readPdu(r,!0)}return i.buffer=e,i};var Req=function(e,t,r,i,n){this.message=t,this.responseCb=i,this.retries=e.retries,this.timeout=e.timeout,this.backoff=e.backoff,this.onResponse=e.onSimpleGetResponse,this.feedCb=r,this.port=n&&n.port?n.port:e.port,this.context=e.context};Req.prototype.getId=function(){return this.message.getReqId()};var Session=function(e,t,r){this.target=e||"127.0.0.1",r=r||{},this.version=r.version?r.version:Version1,this.version==Version3?this.user=t:this.community=t||"public",this.transport=r.transport?r.transport:"udp4",this.port=r.port?r.port:161,this.trapPort=r.trapPort?r.trapPort:162,this.retries=r.retries||0==r.retries?r.retries:1,this.timeout=r.timeout?r.timeout:5e3,this.backoff=r.backoff>=1?r.backoff:1,this.sourceAddress=r.sourceAddress?r.sourceAddress:void 0,this.sourcePort=r.sourcePort?parseInt(r.sourcePort):void 0,this.idBitsSize=r.idBitsSize?parseInt(r.idBitsSize):32,this.context=r.context?r.context:"",this.backwardsGetNexts=void 0===r.backwardsGetNexts||r.backwardsGetNexts,this.reportOidMismatchErrors=void 0!==r.reportOidMismatchErrors&&r.reportOidMismatchErrors,DEBUG=r.debug,this.engine=new Engine(r.engineID),this.reqs={},this.reqCount=0,this.dgram=dgram.createSocket(this.transport),this.dgram.unref();var i=this;this.dgram.on("message",i.onMsg.bind(i)),this.dgram.on("close",i.onClose.bind(i)),this.dgram.on("error",i.onError.bind(i)),(this.sourceAddress||this.sourcePort)&&this.dgram.bind(this.sourcePort,this.sourceAddress)};function _generateId(e){return 16===e?Math.floor(1e4*Math.random())%65535:Math.floor(1e8*Math.random())%4294967295}function subtreeCb(e,t){for(var r=0,i=t.length;i>0;i--)oidInSubtree(e.baseOid,t[i-1].oid)||(r=1,t.pop());if(t.length>0&&e.feedCb(t),r)return!0}function tableColumnsResponseCb(e,t){if(t)e.responseCb(t);else if(e.error)e.responseCb(e.error);else if(e.columns.length>0){var r=e.columns.pop();this.subtree(e.rowOid+r,e.maxRepetitions,tableColumnsFeedCb.bind(this,e),tableColumnsResponseCb.bind(this,e))}else e.responseCb(null,e.table)}function tableColumnsFeedCb(e,t){for(var r=0;r<t.length;r++){if(isVarbindError(t[r]))return e.error=new RequestFailedError(varbindError(t[r])),!0;var i=t[r].oid.replace(e.rowOid,"");if(i&&i!=t[r].oid){var n=i.match(/^(\d+)\.(.+)$/);n&&n[1]>0&&(e.table[n[2]]||(e.table[n[2]]={}),e.table[n[2]][n[1]]=t[r].value)}}}function tableResponseCb(e,t){t?e.responseCb(t):e.error?e.responseCb(e.error):e.responseCb(null,e.table)}function tableFeedCb(e,t){for(var r=0;r<t.length;r++){if(isVarbindError(t[r]))return e.error=new RequestFailedError(varbindError(t[r])),!0;var i=t[r].oid.replace(e.rowOid,"");if(i&&i!=t[r].oid){var n=i.match(/^(\d+)\.(.+)$/);n&&n[1]>0&&(e.table[n[2]]||(e.table[n[2]]={}),e.table[n[2]][n[1]]=t[r].value)}}}function walkCb(e,t,r){var i,n=0;if(t){if(!(t instanceof RequestFailedError))return void e.doneCb(t);if(t.status!=ErrorStatus.NoSuchName)return void e.doneCb(t);n=1}if(r&&r.length){if(this.version==Version2c||this.version==Version3){for(var s=r[0].length;s>0;s--)r[0][s-1].type==ObjectType.EndOfMibView&&(r[0].pop(),n=1);e.feedCb(r[0])&&(n=1),n||(i=r[0][r[0].length-1].oid)}else n||(e.feedCb(r)?n=1:i=r[0].oid);n?e.doneCb(null):this.walk(i,e.maxRepetitions,e.feedCb,e.doneCb,e.baseOid)}else e.doneCb(null)}util.inherits(Session,events.EventEmitter),Session.prototype.close=function(){return this.dgram.close(),this},Session.prototype.cancelRequests=function(e){var t;for(t in this.reqs){var r=this.reqs[t];this.unregisterRequest(r.getId()),r.responseCb(e)}},Session.prototype.get=function(e,t){var r=this.reportOidMismatchErrors;for(var i=[],n=0;n<e.length;n++){var s={oid:e[n]};i.push(s)}return this.simpleGet(GetRequestPdu,(function(e,t){var i=t.pdu,n=[];if(e.message.pdu.varbinds.length!=i.varbinds.length)e.responseCb(new ResponseInvalidError("Requested OIDs do not match response OIDs",ResponseInvalidCode.EReqResOidNoMatch));else{for(var s=0;s<e.message.pdu.varbinds.length;s++){if(r&&e.message.pdu.varbinds[s].oid!=i.varbinds[s].oid)return void e.responseCb(new ResponseInvalidError("OID '"+e.message.pdu.varbinds[s].oid+"' in request at position '"+s+"' does not match OID '"+i.varbinds[s].oid+"' in response at position '"+s+"'",ResponseInvalidCode.EReqResOidNoMatch));n.push(i.varbinds[s])}e.responseCb(null,n)}}),i,t),this},Session.prototype.getBulk=function(){var e,t,r,i,n=this.reportOidMismatchErrors,s=this.backwardsGetNexts;arguments.length>=4?(e=arguments[0],t=arguments[1],r=arguments[2],i=arguments[3]):arguments.length>=3?(e=arguments[0],t=arguments[1],r=10,i=arguments[2]):(e=arguments[0],t=0,r=10,i=arguments[1]);for(var o=[],a=0;a<e.length;a++){var u={oid:e[a]};o.push(u)}var d={nonRepeaters:t,maxRepetitions:r};return this.simpleGet(GetBulkRequestPdu,(function(e,r){for(var i=r.pdu,o=e.message.pdu.varbinds,a=[],u=0;u<o.length&&u<i.varbinds.length;u++){if(isVarbindError(i.varbinds[u])){if(n&&o[u].oid!=i.varbinds[u].oid)return void e.responseCb(new ResponseInvalidError("OID '"+o[u].oid+"' in request at position '"+u+"' does not match OID '"+i.varbinds[u].oid+"' in response at position '"+u+"'",ResponseInvalidCode.EReqResOidNoMatch))}else if(!s&&!oidFollowsOid(o[u].oid,i.varbinds[u].oid))return void e.responseCb(new ResponseInvalidError("OID '"+o[u].oid+"' in request at positiion '"+u+"' does not precede OID '"+i.varbinds[u].oid+"' in response at position '"+u+"'",ResponseInvalidCode.EOutOfOrder));u<t?a.push(i.varbinds[u]):a.push([i.varbinds[u]])}for(var d=o.length-t;u<i.varbinds.length;u++){var c=(u-t)%d+t,p=u-d,l=i.varbinds[p].oid;if(isVarbindError(i.varbinds[u])){if(n&&l!=i.varbinds[u].oid)return void e.responseCb(new ResponseInvalidError("OID '"+l+"' in response at position '"+p+"' does not match OID '"+i.varbinds[u].oid+"' in response at position '"+u+"'",ResponseInvalidCode.EReqResOidNoMatch))}else if(!s&&!oidFollowsOid(l,i.varbinds[u].oid))return void e.responseCb(new ResponseInvalidError("OID '"+l+"' in response at positiion '"+p+"' does not precede OID '"+i.varbinds[u].oid+"' in response at position '"+u+"'",ResponseInvalidCode.EOutOfOrder));a[c].push(i.varbinds[u])}e.responseCb(null,a)}),o,i,d),this},Session.prototype.getNext=function(e,t){var r=this.backwardsGetNexts;for(var i=[],n=0;n<e.length;n++){var s={oid:e[n]};i.push(s)}return this.simpleGet(GetNextRequestPdu,(function(e,t){var i=t.pdu,n=[];if(e.message.pdu.varbinds.length!=i.varbinds.length)e.responseCb(new ResponseInvalidError("Requested OIDs do not match response OIDs",ResponseInvalidCode.EReqResOidNoMatch));else{for(var s=0;s<e.message.pdu.varbinds.length;s++)if(isVarbindError(i.varbinds[s]))n.push(i.varbinds[s]);else{if(!r&&!oidFollowsOid(e.message.pdu.varbinds[s].oid,i.varbinds[s].oid))return void e.responseCb(new ResponseInvalidError("OID '"+e.message.pdu.varbinds[s].oid+"' in request at positiion '"+s+"' does not precede OID '"+i.varbinds[s].oid+"' in response at position '"+s+"'",ResponseInvalidCode.OutOfOrder));n.push(i.varbinds[s])}e.responseCb(null,n)}}),i,t),this},Session.prototype.inform=function(){var e,t,r=arguments[0],i={};if(arguments.length>=4?(e=arguments[1],i=arguments[2],t=arguments[3]):arguments.length>=3?arguments[1].constructor!=Array?(e=[],i=arguments[1],t=arguments[2]):(e=arguments[1],t=arguments[2]):(e=[],t=arguments[1]),this.version!=Version1){"string"!=typeof r&&(r="1.3.6.1.6.3.1.1.5."+(r+1));for(var n=[{oid:"1.3.6.1.2.1.1.3.0",type:ObjectType.TimeTicks,value:i.upTime||Math.floor(100*process.uptime())},{oid:"1.3.6.1.6.3.1.1.4.1.0",type:ObjectType.OID,value:r}],s=0;s<e.length;s++){var o={oid:e[s].oid,type:e[s].type,value:e[s].value};n.push(o)}return i.port=this.trapPort,this.simpleGet(InformRequestPdu,(function(e,t){var r=t.pdu,i=[];if(e.message.pdu.varbinds.length!=r.varbinds.length)e.responseCb(new ResponseInvalidError("Inform OIDs do not match response OIDs",ResponseInvalidCode.EReqResOidNoMatch));else{for(var n=0;n<e.message.pdu.varbinds.length;n++){if(e.message.pdu.varbinds[n].oid!=r.varbinds[n].oid)return void e.responseCb(new ResponseInvalidError("OID '"+e.message.pdu.varbinds[n].oid+"' in inform at positiion '"+n+"' does not match OID '"+r.varbinds[n].oid+"' in response at position '"+n+"'",ResponseInvalidCode.EReqResOidNoMatch));i.push(r.varbinds[n])}e.responseCb(null,i)}}),n,t,i),this}t(new RequestInvalidError("Inform not allowed for SNMPv1"))},Session.prototype.onClose=function(){this.cancelRequests(new Error("Socket forcibly closed")),this.emit("close")},Session.prototype.onError=function(e){this.emit(e)},Session.prototype.onMsg=function(e){try{var t=Message.createFromBuffer(e)}catch(e){return void this.emit("error",e)}var r=this.unregisterRequest(t.getReqId());if(r&&t.processIncomingSecurity(this.user,r.responseCb))if(t.version!=r.message.version)r.responseCb(new ResponseInvalidError("Version in request '"+r.message.version+"' does not match version in response '"+t.version+"'",ResponseInvalidCode.EVersionNoMatch));else if(t.community!=r.message.community)r.responseCb(new ResponseInvalidError("Community '"+r.message.community+"' in request does not match community '"+t.community+"' in response",ResponseInvalidCode.ECommunityNoMatch));else if(t.pdu.type==PduType.Report)if(this.msgSecurityParameters={msgAuthoritativeEngineID:t.msgSecurityParameters.msgAuthoritativeEngineID,msgAuthoritativeEngineBoots:t.msgSecurityParameters.msgAuthoritativeEngineBoots,msgAuthoritativeEngineTime:t.msgSecurityParameters.msgAuthoritativeEngineTime},this.proxy)this.msgSecurityParameters.msgUserName=this.proxy.user.name,this.msgSecurityParameters.msgAuthenticationParameters="",this.msgSecurityParameters.msgPrivacyParameters="";else{if(!r.originalPdu||!r.allowReport)return Array.isArray(t.pdu.varbinds)&&t.pdu.varbinds[0]&&0===t.pdu.varbinds[0].oid.indexOf(UsmStatsBase)?void this.userSecurityModelError(r,t.pdu.varbinds[0].oid):void r.responseCb(new ResponseInvalidError("Unexpected Report PDU",ResponseInvalidCode.EUnexpectedReport));r.originalPdu.contextName=this.context;var i=!t.msgSecurityParameters.msgAuthoritativeEngineBoots&&!t.msgSecurityParameters.msgAuthoritativeEngineTime;this.sendV3Req(r.originalPdu,r.feedCb,r.responseCb,r.options,r.port,i)}else this.proxy?this.onProxyResponse(r,t):t.pdu.type==PduType.GetResponse?r.onResponse(r,t):r.responseCb(new ResponseInvalidError("Unknown PDU type '"+t.pdu.type+"' in response",ResponseInvalidCode.EUnknownPduType))},Session.prototype.onSimpleGetResponse=function(e,t){var r=t.pdu;if(r.errorStatus>0){var i=ErrorStatus[r.errorStatus]||ErrorStatus.GeneralError,n=ErrorStatus[i]||ErrorStatus[ErrorStatus.GeneralError];if(r.errorIndex<=0||r.errorIndex>r.varbinds.length)e.responseCb(new RequestFailedError(i,n));else{var s=new RequestFailedError(i+": "+r.varbinds[r.errorIndex-1].oid,n);e.responseCb(s)}}else e.feedCb(e,t)},Session.prototype.registerRequest=function(e){this.reqs[e.getId()]||(this.reqs[e.getId()]=e,this.reqCount<=0&&this.dgram.ref(),this.reqCount++);var t=this;e.timer=setTimeout((function(){e.retries-- >0?t.send(e):(t.unregisterRequest(e.getId()),e.responseCb(new RequestTimedOutError("Request timed out")))}),e.timeout),e.backoff&&e.backoff>=1&&(e.timeout*=e.backoff)},Session.prototype.send=function(e,t){try{var r=this,i=e.message.toBuffer();this.dgram.send(i,0,i.length,e.port,this.target,(function(i,n){i?e.responseCb(i):t?e.responseCb(null):r.registerRequest(e)}))}catch(t){e.responseCb(t)}return this},Session.prototype.set=function(e,t){var r=this.reportOidMismatchErrors;for(var i=[],n=0;n<e.length;n++){var s={oid:e[n].oid,type:e[n].type,value:e[n].value};i.push(s)}return this.simpleGet(SetRequestPdu,(function(e,t){var i=t.pdu,n=[];if(e.message.pdu.varbinds.length!=i.varbinds.length)e.responseCb(new ResponseInvalidError("Requested OIDs do not match response OIDs",ResponseInvalidCode.EReqResOidNoMatch));else{for(var s=0;s<e.message.pdu.varbinds.length;s++){if(r&&e.message.pdu.varbinds[s].oid!=i.varbinds[s].oid)return void e.responseCb(new ResponseInvalidError("OID '"+e.message.pdu.varbinds[s].oid+"' in request at position '"+s+"' does not match OID '"+i.varbinds[s].oid+"' in response at position '"+s+"'",ResponseInvalidCode.EReqResOidNoMatch));n.push(i.varbinds[s])}e.responseCb(null,n)}}),i,t),this},Session.prototype.simpleGet=function(e,t,r,i,n){var s=_generateId(this.idBitsSize);n=Object.assign({},n,{context:this.context});var o,a,u=SimplePdu.createFromVariables(e,s,r,n);this.version==Version3?this.msgSecurityParameters?this.sendV3Req(u,t,i,n,this.port,!0):this.sendV3Discovery(u,t,i,n):(o=Message.createCommunity(this.version,this.community,u),a=new Req(this,o,t,i,n),this.send(a))},Session.prototype.subtree=function(){var e,t,r,i=arguments[0];arguments.length<4?(e=20,t=arguments[1],r=arguments[2]):(e=arguments[1],t=arguments[2],r=arguments[3]);var n={feedCb:t,doneCb:r,maxRepetitions:e,baseOid:i};return this.walk(i,e,subtreeCb.bind(this,n),r),this},Session.prototype.tableColumns=function(){var e,t,r=arguments[0];arguments.length<4?(t=arguments[2],e=20):(e=arguments[2],t=arguments[3]);var i={responseCb:t,maxRepetitions:e,baseOid:r,rowOid:r+".1.",columns:arguments[1].slice(0),table:{}};if(i.columns.length>0){var n=i.columns.pop();this.subtree(i.rowOid+n,e,tableColumnsFeedCb.bind(this,i),tableColumnsResponseCb.bind(this,i))}return this},Session.prototype.table=function(){var e,t,r=arguments[0];arguments.length<3?(t=arguments[1],e=20):(e=arguments[1],t=arguments[2]);var i={responseCb:t,maxRepetitions:e,baseOid:r,rowOid:r+".1.",table:{}};return this.subtree(r,e,tableFeedCb.bind(this,i),tableResponseCb.bind(this,i)),this},Session.prototype.trap=function(){var e,t,r,i,n=arguments[0],s={};arguments.length>=4?(t=arguments[1],"string"==typeof arguments[2]?s.agentAddr=arguments[2]:arguments[2].constructor!=Array&&(s=arguments[2]),r=arguments[3]):arguments.length>=3?("string"==typeof arguments[1]?(t=[],s.agentAddr=arguments[1]):arguments[1].constructor!=Array?(t=[],s=arguments[1]):(t=arguments[1],s.agentAddr=null),r=arguments[2]):(t=[],r=arguments[1]);for(var o,a=[],u=0;u<t.length;u++){var d={oid:t[u].oid,type:t[u].type,value:t[u].value};a.push(d)}var c=_generateId(this.idBitsSize);if(this.version==Version2c||this.version==Version3?("string"!=typeof n&&(n="1.3.6.1.6.3.1.1.5."+(n+1)),a.unshift({oid:"1.3.6.1.2.1.1.3.0",type:ObjectType.TimeTicks,value:s.upTime||Math.floor(100*process.uptime())},{oid:"1.3.6.1.6.3.1.1.4.1.0",type:ObjectType.OID,value:n}),o=TrapV2Pdu.createFromVariables(c,a,s)):o=TrapPdu.createFromVariables(n,a,s),this.version==Version3){var p={msgAuthoritativeEngineID:this.engine.engineID,msgAuthoritativeEngineBoots:0,msgAuthoritativeEngineTime:0};i=Message.createRequestV3(this.user,p,o)}else i=Message.createCommunity(this.version,this.community,o);return e={id:c,message:i,responseCb:r,port:this.trapPort},this.send(e,!0),this},Session.prototype.unregisterRequest=function(e){var t=this.reqs[e];return t?(delete this.reqs[e],clearTimeout(t.timer),delete t.timer,this.reqCount--,this.reqCount<=0&&this.dgram.unref(),t):null},Session.prototype.walk=function(){var e,t,r,i=arguments[0];arguments.length<4?(e=20,t=arguments[1],r=arguments[2]):(e=arguments[1],t=arguments[2],r=arguments[3]);var n={maxRepetitions:e,feedCb:t,doneCb:r};return this.version==Version2c||this.version==Version3?this.getBulk([i],0,e,walkCb.bind(this,n)):this.getNext([i],walkCb.bind(this,n)),this},Session.prototype.sendV3Req=function(e,t,r,i,n,s){var o=Message.createRequestV3(this.user,this.msgSecurityParameters,e),a=new Req(this,o,t,r,i||{});a.port=n,a.originalPdu=e,a.allowReport=s,this.send(a)},Session.prototype.sendV3Discovery=function(e,t,r,i){var n=createDiscoveryPdu(this.context),s=Message.createDiscoveryV3(n),o=new Req(this,s,t,r,i);o.originalPdu=e,o.allowReport=!0,this.send(o)},Session.prototype.userSecurityModelError=function(e,t){var r=t.replace(UsmStatsBase+".","").replace(/\.0$/,""),i=UsmStats[r]||"Unexpected Report PDU";e.responseCb(new ResponseInvalidError(i,ResponseInvalidCode.EAuthFailure))},Session.prototype.onProxyResponse=function(e,t){t.version==Version3?(t.pdu.contextName=this.proxy.context,t.user=e.proxiedUser,t.setAuthentication(!(e.proxiedUser.level==SecurityLevel.noAuthNoPriv)),t.setPrivacy(e.proxiedUser.level==SecurityLevel.authPriv),t.msgSecurityParameters={msgAuthoritativeEngineID:e.proxiedEngine.engineID,msgAuthoritativeEngineBoots:e.proxiedEngine.engineBoots,msgAuthoritativeEngineTime:e.proxiedEngine.engineTime,msgUserName:e.proxiedUser.name,msgAuthenticationParameters:"",msgPrivacyParameters:""},t.buffer=null,t.pdu.contextEngineID=t.msgSecurityParameters.msgAuthoritativeEngineID,t.pdu.contextName=this.proxy.context,t.pdu.id=e.proxiedPduId,this.proxy.listener.send(t,e.proxiedRinfo)):this.callback(new RequestFailedError("Only SNMP version 3 contexts are supported"))},Session.create=function(e,t,r){var i=r&&r.version?r.version:Version1;if(i!=Version1&&i!=Version2c)throw new ResponseInvalidError("SNMP community session requested but version '"+r.version+"' specified in options not valid",ResponseInvalidCode.EVersionNoMatch);return r||(r={}),r.version=i,new Session(e,t,r)},Session.createV3=function(e,t,r){if(r&&r.version&&r.version!=Version3)throw new ResponseInvalidError("SNMPv3 session requested but version '"+r.version+"' specified in options",ResponseInvalidCode.EVersionNoMatch);return r||(r={}),r.version=Version3,new Session(e,t,r)};var Engine=function(e,t,r){e?e instanceof Buffer?this.engineID=e:(e=e.replace("0x",""),this.engineID=Buffer.from((e.toString().length%2==1?"0":"")+e.toString(),"hex")):this.generateEngineID(),this.engineBoots=0,this.engineTime=10};Engine.prototype.generateEngineID=function(){this.engineID=Buffer.alloc(17),this.engineID.fill("8000B98380","hex",0,5),this.engineID.fill(crypto.randomBytes(12),5,17,"hex")};var Listener=function(e,t){this.receiver=t,this.callback=t.onMsg,this.family=e.transport||"udp4",this.port=e.port||161,this.address=e.address,this.disableAuthorization=e.disableAuthorization||!1};Listener.prototype.startListening=function(){var e=this;this.dgram=dgram.createSocket(this.family),this.dgram.on("error",e.receiver.callback),this.dgram.bind(this.port,this.address),this.dgram.on("message",e.callback.bind(e.receiver))},Listener.prototype.send=function(e,t){var r=e.toBuffer();this.dgram.send(r,0,r.length,t.port,t.address,(function(e,t){e&&console.error("Error sending: "+e.message)}))},Listener.formatCallbackData=function(e,t){return e.contextEngineID&&(e.contextEngineID=e.contextEngineID.toString("hex")),delete e.nonRepeaters,delete e.maxRepetitions,{pdu:e,rinfo:t}},Listener.processIncoming=function(e,t,r){var i=Message.createFromBuffer(e);if(i.version==Version3){if(i.user=t.users.filter((e=>e.name==i.msgSecurityParameters.msgUserName))[0],i.disableAuthentication=t.disableAuthorization,!i.user){if(""!=i.msgSecurityParameters.msgUserName&&!t.disableAuthorization)return void r(new RequestFailedError("Local user not found for message with user "+i.msgSecurityParameters.msgUserName));if(i.hasAuthentication())return void r(new RequestFailedError("Local user not found and message requires authentication with user "+i.msgSecurityParameters.msgUserName));i.user={name:"",level:SecurityLevel.noAuthNoPriv}}if((i.user.level==SecurityLevel.authNoPriv||i.user.level==SecurityLevel.authPriv)&&!i.hasAuthentication())return void r(new RequestFailedError("Local user "+i.msgSecurityParameters.msgUserName+" requires authentication but message does not provide it"));if(i.user.level==SecurityLevel.authPriv&&!i.hasPrivacy())return void r(new RequestFailedError("Local user "+i.msgSecurityParameters.msgUserName+" requires privacy but message does not provide it"));if(!i.processIncomingSecurity(i.user,r))return}else if(!t.communities.filter((e=>e==i.community))[0]&&!t.disableAuthorization)return void r(new RequestFailedError("Local community not found for message with community "+i.community));return i},Listener.prototype.close=function(){this.dgram&&this.dgram.close()};var Authorizer=function(e){this.communities=[],this.users=[],this.disableAuthorization=e.disableAuthorization,this.accessControlModelType=e.accessControlModelType||AccessControlModelType.None,this.accessControlModelType==AccessControlModelType.None?this.accessControlModel=null:this.accessControlModelType==AccessControlModelType.Simple&&(this.accessControlModel=new SimpleAccessControlModel)};Authorizer.prototype.addCommunity=function(e){this.getCommunity(e)||(this.communities.push(e),this.accessControlModelType==AccessControlModelType.Simple&&this.accessControlModel.setCommunityAccess(e,AccessLevel.ReadOnly))},Authorizer.prototype.getCommunity=function(e){return this.communities.filter((t=>t==e))[0]||null},Authorizer.prototype.getCommunities=function(){return this.communities},Authorizer.prototype.deleteCommunity=function(e){var t=this.communities.indexOf(e);t>-1&&this.communities.splice(t,1)},Authorizer.prototype.addUser=function(e){this.getUser(e.name)&&this.deleteUser(e.name),this.users.push(e),this.accessControlModelType==AccessControlModelType.Simple&&this.accessControlModel.setUserAccess(e.name,AccessLevel.ReadOnly)},Authorizer.prototype.getUser=function(e){return this.users.filter((t=>t.name==e))[0]||null},Authorizer.prototype.getUsers=function(){return this.users},Authorizer.prototype.deleteUser=function(e){var t=this.users.findIndex((t=>t.name==e));t>-1&&this.users.splice(t,1)},Authorizer.prototype.getAccessControlModelType=function(){return this.accessControlModelType},Authorizer.prototype.getAccessControlModel=function(){return this.accessControlModel},Authorizer.prototype.isAccessAllowed=function(e,t,r){return!this.accessControlModel||this.accessControlModel.isAccessAllowed(e,t,r)};var SimpleAccessControlModel=function(){this.communitiesAccess=[],this.usersAccess=[]};SimpleAccessControlModel.prototype.getCommunityAccess=function(e){return this.communitiesAccess.find((t=>t.community==e))},SimpleAccessControlModel.prototype.getCommunityAccessLevel=function(e){var t=this.getCommunityAccess(e);return t?t.level:AccessLevel.None},SimpleAccessControlModel.prototype.getCommunitiesAccess=function(){return this.communitiesAccess},SimpleAccessControlModel.prototype.setCommunityAccess=function(e,t){let r=this.getCommunityAccess(e);r?r.level=t:(this.communitiesAccess.push({community:e,level:t}),this.communitiesAccess.sort(((e,t)=>e.community>t.community?1:-1)))},SimpleAccessControlModel.prototype.removeCommunityAccess=function(e){this.communitiesAccess.splice(this.communitiesAccess.findIndex((t=>t.community==e)),1)},SimpleAccessControlModel.prototype.getUserAccess=function(e){return this.usersAccess.find((t=>t.userName==e))},SimpleAccessControlModel.prototype.getUserAccessLevel=function(e){var t=this.getUserAccess(e);return t?t.level:AccessLevel.None},SimpleAccessControlModel.prototype.getUsersAccess=function(){return this.usersAccess},SimpleAccessControlModel.prototype.setUserAccess=function(e,t){let r=this.getUserAccess(e);r?r.level=t:(this.usersAccess.push({userName:e,level:t}),this.usersAccess.sort(((e,t)=>e.userName>t.userName?1:-1)))},SimpleAccessControlModel.prototype.removeUserAccess=function(e){this.usersAccess.splice(this.usersAccess.findIndex((t=>t.userName==e)),1)},SimpleAccessControlModel.prototype.isAccessAllowed=function(e,t,r){var i,n;switch(e){case Version1:case Version2c:i=this.getCommunityAccessLevel(t);break;case Version3:i=this.getUserAccessLevel(t)}switch(r){case PduType.SetRequest:n=AccessLevel.ReadWrite;break;case PduType.GetRequest:case PduType.GetNextRequest:case PduType.GetBulkRequest:n=AccessLevel.ReadOnly;break;default:n=AccessLevel.None}switch(n){case AccessLevel.ReadWrite:return i==AccessLevel.ReadWrite;case AccessLevel.ReadOnly:return i==AccessLevel.ReadWrite||i==AccessLevel.ReadOnly;case AccessLevel.None:return!0;default:return!1}};var Receiver=function(e,t){DEBUG=e.debug,this.listener=new Listener(e,this),this.authorizer=new Authorizer(e),this.engine=new Engine(e.engineID),this.engineBoots=0,this.engineTime=10,this.disableAuthorization=!1,this.callback=t,this.family=e.transport||"udp4",this.port=e.port||162,e.port=this.port,this.disableAuthorization=e.disableAuthorization||!1,this.includeAuthentication=e.includeAuthentication||!1,this.context=e&&e.context?e.context:"",this.listener=new Listener(e,this)};Receiver.prototype.getAuthorizer=function(){return this.authorizer},Receiver.prototype.onMsg=function(e,t){let r;try{r=Listener.processIncoming(e,this.authorizer,this.callback)}catch(r){return void this.callback(new ProcessingError("Failure to process incoming message",r,t,e))}if(r)if(r.pdu.type!=PduType.GetRequest)r.pdu.type==PduType.Trap||r.pdu.type==PduType.TrapV2?this.callback(null,this.formatCallbackData(r,t)):r.pdu.type==PduType.InformRequest?(r.pdu.type=PduType.GetResponse,r.buffer=null,r.setReportable(!1),this.listener.send(r,t),r.pdu.type=PduType.InformRequest,this.callback(null,this.formatCallbackData(r,t))):this.callback(new RequestInvalidError("Unexpected PDU type "+r.pdu.type+" ("+PduType[r.pdu.type]+")"));else{if(r.version!=Version3)return void this.callback(new RequestInvalidError("Only SNMPv3 discovery GetRequests are supported"));if(r.hasAuthentication())return void this.callback(new RequestInvalidError("Only discovery (noAuthNoPriv) GetRequests are supported but this message has authentication"));if(!r.isReportable())return void this.callback(new RequestInvalidError("Only discovery GetRequests are supported and this message does not have the reportable flag set"));let e=r.createReportResponseMessage(this.engine,this.context);this.listener.send(e,t)}},Receiver.prototype.formatCallbackData=function(e,t){e.pdu.contextEngineID&&(e.pdu.contextEngineID=e.pdu.contextEngineID.toString("hex")),delete e.pdu.nonRepeaters,delete e.pdu.maxRepetitions;const r={pdu:e.pdu,rinfo:t};return this.includeAuthentication&&(e.community?r.pdu.community=e.community:e.user&&(r.pdu.user=e.user.name)),r},Receiver.prototype.close=function(){this.listener.close()},Receiver.create=function(e,t){var r=new Receiver(e,t);return r.listener.startListening(),r};var ModuleStore=function(){this.parser=mibparser()};ModuleStore.prototype.getSyntaxTypes=function(){var e={};for(var t of(Object.assign(e,ObjectType),Object.values(this.parser.Modules)))for(var r of Object.values(t))"TEXTUAL-CONVENTION"==r.MACRO&&r.SYNTAX&&!e[r.ObjectName]&&("object"==typeof r.SYNTAX?e[r.ObjectName]=r.SYNTAX:e[r.ObjectName]=e[r.SYNTAX]);return e},ModuleStore.prototype.loadFromFile=function(e){this.parser.Import(e),this.parser.Serialize()},ModuleStore.prototype.getModule=function(e){return this.parser.Modules[e]},ModuleStore.prototype.getModules=function(e){var t={};for(var r of Object.keys(this.parser.Modules))(e||-1==ModuleStore.BASE_MODULES.indexOf(r))&&(t[r]=this.parser.Modules[r]);return t},ModuleStore.prototype.getModuleNames=function(e){var t=[];for(var r of Object.keys(this.parser.Modules))(e||-1==ModuleStore.BASE_MODULES.indexOf(r))&&t.push(r);return t},ModuleStore.prototype.getProvidersForModule=function(e){var t,r,i,n,s,o,a,u=this.parser.Modules[e],d=[],c=[];if(!u)throw new ReferenceError("MIB module "+e+" not loaded");r=this.getSyntaxTypes(),i=Object.values(u);for(var p=0;p<i.length;p++){var l=(t=i[p]).SYNTAX,h=t.ACCESS,g=void 0!==t["MAX-ACCESS"]?t["MAX-ACCESS"]:h?AccessToMaxAccess[h]:"not-accessible",y=t.DEFVAL;if(l)if(l=(o=ModuleStore.getConstraintsFromSyntax(l,r)).syntax,a=o.constraints,l.startsWith("SEQUENCE OF"))for((n={tableName:t.ObjectName,type:MibProviderType.Table,tableColumns:[],tableIndex:[1]}).maxAccess=MaxAccess[g];n||p>=i.length;){if(!(t=i[++p])){c.push(n),n=null,p--;break}if(l=t.SYNTAX,h=t.ACCESS,g=void 0!==t["MAX-ACCESS"]?t["MAX-ACCESS"]:h?AccessToMaxAccess[h]:"not-accessible",y=t.DEFVAL,l=(o=ModuleStore.getConstraintsFromSyntax(l,r)).syntax,a=o.constraints,"SEQUENCE"==t.MACRO);else if(t["OBJECT IDENTIFIER"])if((s=t["OBJECT IDENTIFIER"].split(" ")[0])==n.tableName){if(n.name=t.ObjectName,n.oid=t.OID,t.INDEX)for(var m of(n.tableIndex=[],t.INDEX))(m=m.trim()).includes(" ")?"IMPLIED"==m.split(" ")[0]?n.tableIndex.push({columnName:m.split(" ")[1],implied:!0}):n.tableIndex.push({columnName:m.split(" ").slice(-1)[0]}):n.tableIndex.push({columnName:m});t.AUGMENTS&&(n.tableAugments=t.AUGMENTS[0].trim(),n.tableIndex=null)}else if(s==n.name){var f={number:parseInt(t["OBJECT IDENTIFIER"].split(" ")[1]),name:t.ObjectName,type:r[l],maxAccess:MaxAccess[g]};a&&(f.constraints=a),y&&(f.defVal=y),"RowStatus"==l&&"IMPORTS"in u&&Array.isArray(u.IMPORTS["SNMPv2-TC"])&&u.IMPORTS["SNMPv2-TC"].includes("RowStatus")&&(f.rowStatus=!0),n.tableColumns.push(f)}else c.push(n),n=null,p--;else;}else if("OBJECT-TYPE"==t.MACRO){let e=r[l];"object"==typeof e&&(e=r[Object.keys(e)[0]]);var b={name:t.ObjectName,type:MibProviderType.Scalar,oid:t.OID,scalarType:e,maxAccess:MaxAccess[g]};y&&(b.defVal=y),a&&(b.constraints=a),d.push(b)}}return d.concat(c)},ModuleStore.prototype.loadBaseModules=function(){for(var e of ModuleStore.BASE_MODULES)this.parser.Import(__dirname+"/lib/mibs/"+e+".mib");this.parser.Serialize()},ModuleStore.getConstraintsFromSyntax=function(e,t){let r;if("object"==typeof t[e]&&(e=t[e]),"object"==typeof e){let t=e[Object.keys(e)[0]];t.ranges?(r={ranges:t.ranges},e=Object.keys(e)[0]):t.sizes?(r={sizes:t.sizes},e=Object.keys(e)[0]):(r={enumeration:e.INTEGER},e="INTEGER")}else r=null;return{constraints:r,syntax:e}},ModuleStore.create=function(){var e=new ModuleStore;return e.loadBaseModules(),e},ModuleStore.BASE_MODULES=["RFC1155-SMI","RFC1158-MIB","RFC-1212","RFC1213-MIB","SNMPv2-SMI","SNMPv2-CONF","SNMPv2-TC","SNMPv2-MIB"];var MibNode=function(e,t){this.address=e,this.oid=this.address.join("."),this.parent=t,this.children={}};MibNode.prototype.child=function(e){return this.children[e]},MibNode.prototype.listChildren=function(e){var t=[];return e=e||0,this.children.forEach((function(r,i){i>=e&&t.push(i)})),t.sort((function(e,t){return e-t})),t},MibNode.prototype.findChildImmediatelyBefore=function(e){var t=Object.keys(this.children).sort((function(e,t){return e-t}));if(0===t.length)return null;for(var r=0;r<t.length;r++)if(e<t[r])return 0===r?null:this.children[t[r-1]];return this.children[t[t.length-1]]},MibNode.prototype.isDescendant=function(e){return MibNode.oidIsDescended(this.address,e)},MibNode.prototype.isAncestor=function(e){return MibNode.oidIsDescended(e,this.address)},MibNode.prototype.getAncestorProvider=function(){return this.provider?this:this.parent?this.parent.getAncestorProvider():null},MibNode.prototype.getTableColumnFromInstanceNode=function(){return this.parent&&this.parent.provider?this.address[this.address.length-1]:this.parent?this.parent.getTableColumnFromInstanceNode():null},MibNode.prototype.getConstraintsFromProvider=function(){var e=this.getAncestorProvider();if(!e)return null;var t=e.provider;if(t.type==MibProviderType.Scalar)return t.constraints;if(t.type==MibProviderType.Table){var r=this.getTableColumnFromInstanceNode();if(!r)return null;var i=t.tableColumns.filter((e=>e.number==r))[0];return i?i.constraints:null}return null},MibNode.prototype.setValue=function(e){var t,r,i,n,s=!1,o=this.getConstraintsFromProvider();if(!o)return this.value=e,!0;if(o.enumeration){if(!o.enumeration[e])return!1}else if(o.ranges){for(n of o.ranges)if(r="min"in n?n.min:Number.MIN_SAFE_INTEGER,i="max"in n?n.max:Number.MAX_SAFE_INTEGER,e>=r&&e<=i){s=!0;break}if(!s)return!1}else if(o.sizes){if(void 0===e.length)return!1;for(n of(t=e.length,o.sizes))if(r="min"in n?n.min:Number.MIN_SAFE_INTEGER,i="max"in n?n.max:Number.MAX_SAFE_INTEGER,t>=r&&t<=i){s=!0;break}if(!s)return!1}return this.value=e,!0},MibNode.prototype.getInstanceNodeForTableRow=function(){var e=Object.keys(this.children).length;return 0==e?null!=this.value?this:null:1==e?this.children[0].getInstanceNodeForTableRow():e>1?null:void 0},MibNode.prototype.getInstanceNodeForTableRowIndex=function(e){var t;if(0==Object.keys(this.children).length)return null!=this.value?this:null;if(0==e.length)return this.getInstanceNodeForTableRow();var r=e[0];return null==r?null:(t=e.slice(1),this.children[r]?this.children[r].getInstanceNodeForTableRowIndex(t):null)},MibNode.prototype.getInstanceNodesForColumn=function(){for(var e=this,t=this,r=[];t&&(t==e||e.isAncestor(t.address));)(t=t.getNextInstanceNode())&&e.isAncestor(t.address)&&r.push(t);return r},MibNode.prototype.getNextInstanceNode=function(){var e,t,r=this;if(null!=this.value)for(r=this;r;){if(e=r.address.slice(-1)[0],!(r=r.parent))return null;var i=(t=Object.keys(r.children).sort(((e,t)=>e-t))).indexOf(e.toString());if(i+1<t.length){r=r.children[t[i+1]];break}}for(;r;){if(null!=r.value)return r;if(t=Object.keys(r.children).sort(((e,t)=>e-t)),!(r=r.children[t[0]]))return null}},MibNode.prototype.delete=function(){if(Object.keys(this.children)>0)throw new Error("Cannot delete non-leaf MIB node");var e=this.address.slice(-1)[0];delete this.parent.children[e],this.parent=null},MibNode.prototype.pruneUpwards=function(){if(this.parent&&0==Object.keys(this.children).length){var e=this.address.splice(-1)[0].toString();delete this.parent.children[e],this.parent.pruneUpwards(),this.parent=null}},MibNode.prototype.dump=function(e){var t;for(var r of(e.leavesOnly&&!e.showProviders||!this.provider?e.leavesOnly&&0!=Object.keys(this.children).length||(null!=this.value?(t=" = ",t+=e.showTypes?ObjectType[this.valueType]+": ":"",t+=e.showValues?this.value:""):t="",console.log(this.oid+t)):console.log(this.oid+" ["+MibProviderType[this.provider.type]+": "+this.provider.name+"]"),Object.keys(this.children).sort(((e,t)=>e-t))))this.children[r].dump(e)},MibNode.oidIsDescended=function(e,t){var r=Mib.convertOidToAddress(t),i=Mib.convertOidToAddress(e),n=!0;return!(i.length<=r.length)&&(r.forEach((function(e,t){i[t]!==r[t]&&(n=!1)})),n)};var Mib=function(){var e;this.root=new MibNode([],null),this.providerNodes={},e=this.providersByOid={},this.providers=new Proxy({},{set:function(t,r,i){t[r]=i,e[i.oid]=i},deleteProperty:function(t,r){delete e[t[r].oid],delete t[r]}})};Mib.prototype.addNodesForOid=function(e){var t=Mib.convertOidToAddress(e);return this.addNodesForAddress(t)},Mib.prototype.addNodesForAddress=function(e){var t,r;for(t=this.root,r=0;r<e.length;r++)t.children.hasOwnProperty(e[r])||(t.children[e[r]]=new MibNode(e.slice(0,r+1),t)),t=t.children[e[r]];return t},Mib.prototype.lookup=function(e){var t;return t=Mib.convertOidToAddress(e),this.lookupAddress(t)},Mib.prototype.lookupAddress=function(e){var t,r;for(r=this.root,t=0;t<e.length;t++){if(!r.children.hasOwnProperty(e[t]))return null;r=r.children[e[t]]}return r},Mib.prototype.getTreeNode=function(e){var t,r=Mib.convertOidToAddress(e);if(t=this.lookupAddress(r))return t;for(;r.length>0;){var i=r.pop(),n=this.lookupAddress(r);if(n){if(!(t=n.findChildImmediatelyBefore(i)))return n;for(;;){var s=Object.keys(t.children).sort(((e,t)=>e-t));if(0==s.length)return t;t=t.children[s[s.length-1]]}}}return this.root},Mib.prototype.getProviderNodeForInstance=function(e){return e.provider?null:e.getAncestorProvider()},Mib.prototype.addProviderToNode=function(e){var t=this.addNodesForOid(e.oid);return t.provider=e,e.type==MibProviderType.Table&&(e.tableIndex||(e.tableIndex=[1])),this.providerNodes[e.name]=t,t},Mib.prototype.getColumnFromProvider=function(e,t){var r=null;return t.columnName?r=e.tableColumns.filter((e=>e.name==t.columnName))[0]:void 0!==t.columnNumber&&null!==t.columnNumber&&(r=e.tableColumns.filter((e=>e.number==t.columnNumber))[0]),r},Mib.prototype.populateIndexEntryFromColumn=function(e,t,r){var i=null;if(!t.columnName&&!t.columnNumber)throw new Error("Index entry "+r+": does not have either a columnName or columnNumber");if(t.foreign)i=this.getColumnFromProvider(this.providers[t.foreign],t);else if(!(i=this.getColumnFromProvider(e,t)))for(var n of Object.values(this.providers).filter((e=>e.type==MibProviderType.Table)))if(i=this.getColumnFromProvider(n,t)){t.foreign=n.name;break}if(!i)throw new Error("Could not find column for index entry with column "+t.columnName);if(t.columnName&&t.columnName!=i.name)throw new Error("Index entry "+r+": Calculated column name "+i.name+"does not match supplied column name "+t.columnName);if(t.columnNumber&&t.columnNumber!=i.number)throw new Error("Index entry "+r+": Calculated column number "+i.number+" does not match supplied column number "+t.columnNumber);t.columnName||(t.columnName=i.name),t.columnNumber||(t.columnNumber=i.number),t.type=i.type},Mib.prototype.registerProvider=function(e){if(this.providers[e.name]=e,e.type==MibProviderType.Table)if(e.tableAugments){if(e.tableAugments==e.name)throw new Error("Table "+e.name+" cannot augment itself");var t=this.providers[e.tableAugments];if(!t)throw new Error("Cannot find base table "+e.tableAugments+" to augment");e.tableIndex=JSON.parse(JSON.stringify(t.tableIndex)),e.tableIndex.map((e=>e.foreign=t.name))}else{e.tableIndex||(e.tableIndex=[1]);for(var r=0;r<e.tableIndex.length;r++){var i=e.tableIndex[r];"number"==typeof i?e.tableIndex[r]={columnNumber:i}:"string"==typeof i&&(e.tableIndex[r]={columnName:i}),i=e.tableIndex[r],this.populateIndexEntryFromColumn(e,i,r)}}},Mib.prototype.setScalarDefaultValue=function(e,t){this.getProvider(e).defVal=t},Mib.prototype.setTableRowDefaultValues=function(e,t){let r=this.getProvider(e).tableColumns;if(t.length!=r.length)throw new Error(`Incorrect values length: got ${t.length}; expected ${r.length}`);r.forEach(((e,r)=>{void 0!==t[r]&&(e.defVal=t[r])}))},Mib.prototype.setScalarRanges=function(e,t){this.getProvider(e).constraints={ranges:t}},Mib.prototype.setTableColumnRanges=function(e,t,r){this.getProvider(e).tableColumns[t].constraints={ranges:r}},Mib.prototype.setScalarSizes=function(e,t){this.getProvider(e).constraints={sizes:t}},Mib.prototype.setTableColumnSizes=function(e,t,r){this.getProvider(e).tableColumns[t].constraints={sizes:r}},Mib.prototype.registerProviders=function(e){for(var t of e)this.registerProvider(t)},Mib.prototype.unregisterProvider=function(e){var t=this.providerNodes[e];if(t){var r=t.parent;t.delete(),r.pruneUpwards(),delete this.providerNodes[e]}delete this.providers[e]},Mib.prototype.getProvider=function(e){return this.providers[e]},Mib.prototype.getProviders=function(){return this.providers},Mib.prototype.dumpProviders=function(){var e;for(var t of Object.values(this.providers))e=t.type==MibProviderType.Scalar?ObjectType[t.scalarType]:"Columns = "+t.tableColumns.length,console.log(MibProviderType[t.type]+": "+t.name+" ("+t.oid+"): "+e)},Mib.prototype.getScalarValue=function(e){var t=this.providerNodes[e];if(!t||!t.provider||t.provider.type!=MibProviderType.Scalar)throw new ReferenceError("Failed to get node for registered MIB provider "+e);var r=t.address.concat([0]);if(!this.lookup(r))throw new Error("Failed created instance node for registered MIB provider "+e);return this.lookup(r).value},Mib.prototype.setScalarValue=function(e,t){var r,i,n;if(!this.providers[e])throw new ReferenceError("Provider "+e+" not registered with this MIB");if((r=this.providerNodes[e])||(r=this.addProviderToNode(this.providers[e])),n=r.provider,!r||!n||n.type!=MibProviderType.Scalar)throw new ReferenceError("Could not find MIB node for registered provider "+e);var s=r.address.concat([0]);(i=this.lookup(s))||(this.addNodesForAddress(s),(i=this.lookup(s)).valueType=n.scalarType),i.value=t},Mib.prototype.getProviderNodeForTable=function(e){var t,r;if(!(t=this.providerNodes[e]))throw new ReferenceError("No MIB provider registered for "+e);if(r=t.provider,!t)throw new ReferenceError("No MIB provider definition for registered provider "+e);if(r.type!=MibProviderType.Table)throw new TypeError("Registered MIB provider "+e+" is not of the correct type (is type "+MibProviderType[r.type]+")");return t},Mib.prototype.getOidAddressFromValue=function(e,t){var r;switch(t.type){case ObjectType.OID:r=e.split(".");break;case ObjectType.OctetString:r=e instanceof Buffer?Array.prototype.slice.call(e):[...e].map((e=>e.charCodeAt()));break;case ObjectType.IpAddress:return e.split(".");default:return[e]}return t.implied||t.length||r.unshift(r.length),r},Mib.prototype.getTableRowInstanceFromRow=function(e,t){var r,i,n,s=[];r=e.tableIndex.filter((e=>e.foreign));for(var o=0;o<r.length;o++)n=this.getOidAddressFromValue(t[o],r[o]),s=s.concat(n);for(var a of e.tableIndex.filter((e=>!e.foreign)))i=e.tableColumns.findIndex((e=>e.number==a.columnNumber)),n=this.getOidAddressFromValue(t[r.length+i],a),s=s.concat(n);return s},Mib.getRowIndexFromOid=function(e,t){var r,i=e.split("."),n=0,s=[];for(var o of t)switch(o.type){case ObjectType.OID:n=o.implied?i.length:i.shift(),r=i.splice(0,n),s.push(r.join("."));break;case ObjectType.IpAddress:n=4,r=i.splice(0,n),s.push(r.join("."));break;case ObjectType.OctetString:n=o.implied?i.length:i.shift(),r=(r=i.splice(0,n)).map((e=>String.fromCharCode(e))).join(""),s.push(r);break;default:s.push(parseInt(i.shift()))}return s},Mib.prototype.getTableRowInstanceFromRowIndex=function(e,t){for(var r,i,n=[],s=0;s<e.tableIndex.length;s++)r=e.tableIndex[s],i=t[s],n=n.concat(this.getOidAddressFromValue(i,r));return n},Mib.prototype.addTableRow=function(e,t){var r,i,n,s,o,a;this.providers[e]&&!this.providerNodes[e]&&this.addProviderToNode(this.providers[e]),a=(i=(r=this.getProviderNodeForTable(e)).provider).tableIndex.filter((e=>e.foreign)).length,n=this.getTableRowInstanceFromRow(i,t);for(var u=0;u<i.tableColumns.length;u++){var d=i.tableColumns[u];(!i.tableIndex.some((e=>e.columnNumber==d.number))||d.maxAccess!==MaxAccess["not-accessible"]&&d.maxAccess!==MaxAccess["accessible-for-notify"])&&(s=r.address.concat(d.number).concat(n),this.addNodesForAddress(s),(o=this.lookup(s)).valueType=d.type,o.value=t[a+u])}},Mib.prototype.getTableColumnDefinitions=function(e){return this.getProviderNodeForTable(e).provider.tableColumns},Mib.prototype.getTableColumnCells=function(e,t,r){var i=this.providers[e].tableIndex,n=this.getProviderNodeForTable(e).children[t];if(!n)return null;var s,o=n.getInstanceNodesForColumn(),a=[],u=[];for(var d of o)s=Mib.getSubOidFromBaseOid(d.oid,n.oid),a.push(Mib.getRowIndexFromOid(s,i)),u.push(d.value);return r?[a,u]:u},Mib.prototype.getTableRowCells=function(e,t){var r,i,n,s,o,a=[],u=!1;for(var d of(r=this.providers[e],i=this.getProviderNodeForTable(e),s=this.getTableRowInstanceFromRowIndex(r,t),Object.keys(i.children)))(n=i.children[d])&&(o=n.getInstanceNodeForTableRowIndex(s))?(a.push(o.value),u=!0):a.push(null);return u?a:null},Mib.prototype.getTableCells=function(e,t,r){var i,n,s=[];for(var o of(i=this.getProviderNodeForTable(e),Object.keys(i.children)))n=this.getTableColumnCells(e,o,r),r?(s.push(...n),r=!1):s.push(n);return t?Object.keys(s[0]).map((function(e){return s.map((function(t){return t[e]}))})):s},Mib.prototype.getTableSingleCell=function(e,t,r){var i,n,s;return i=this.providers[e],n=this.getProviderNodeForTable(e),s=this.getTableRowInstanceFromRowIndex(i,r),n.children[t].getInstanceNodeForTableRowIndex(s).value},Mib.prototype.setTableSingleCell=function(e,t,r,i){var n,s,o;n=this.providers[e],s=this.getProviderNodeForTable(e),o=this.getTableRowInstanceFromRowIndex(n,r),s.children[t].getInstanceNodeForTableRowIndex(o).value=i},Mib.prototype.deleteTableRow=function(e,t){var r,i,n,s,o;for(var a of(r=this.providers[e],i=this.getProviderNodeForTable(e),n=this.getTableRowInstanceFromRowIndex(r,t),Object.keys(i.children))){if(!(s=i.children[a].getInstanceNodeForTableRowIndex(n)))throw new ReferenceError("Cannot find row for index "+t+" at registered provider "+e);o=s.parent,s.delete(),o.pruneUpwards()}return 0===Object.keys(this.providerNodes[e].children).length&&delete this.providerNodes[e],!0},Mib.prototype.dump=function(e){e||(e={});var t={leavesOnly:void 0===e.leavesOnly||e.leavesOnly,showProviders:void 0===e.showProviders||e.showProviders,showValues:void 0===e.showValues||e.showValues,showTypes:void 0===e.showTypes||e.showTypes};this.root.dump(t)},Mib.convertOidToAddress=function(e){var t,r,i;if("object"==typeof e&&util.isArray(e))t=e;else{if("string"!=typeof e)throw new TypeError("oid (string or array) is required");t=e.split(".")}if(t.length<1)throw new RangeError("object identifier is too short");for(r=[],i=0;i<t.length;i++){var n;if(""!==t[i]){if(!0===t[i]||!1===t[i])throw new TypeError("object identifier component "+t[i]+" is malformed");if(n=Number(t[i]),isNaN(n))throw new TypeError("object identifier component "+t[i]+" is malformed");if(n%1!=0)throw new TypeError("object identifier component "+t[i]+" is not an integer");if(0===i&&n>2)throw new RangeError("object identifier does not begin with 0, 1, or 2");if(1===i&&n>39)throw new RangeError("object identifier second component "+n+" exceeds encoding limit of 39");if(n<0)throw new RangeError("object identifier component "+t[i]+" is negative");if(n>MAX_SIGNED_INT32)throw new RangeError("object identifier component "+t[i]+" is too large");r.push(n)}}return r},Mib.getSubOidFromBaseOid=function(e,t){return e.substring(t.length+1)},Mib.create=function(){return new Mib};var MibRequest=function(e){this.operation=e.operation,this.address=Mib.convertOidToAddress(e.oid),this.oid=this.address.join("."),this.providerNode=e.providerNode,this.instanceNode=e.instanceNode};MibRequest.prototype.isScalar=function(){return this.providerNode&&this.providerNode.provider&&this.providerNode.provider.type==MibProviderType.Scalar},MibRequest.prototype.isTabular=function(){return this.providerNode&&this.providerNode.provider&&this.providerNode.provider.type==MibProviderType.Table};var Agent=function(e,t,r){DEBUG=e.debug,this.listener=new Listener(e,this),this.engine=new Engine(e.engineID),this.authorizer=new Authorizer(e),this.callback=t||function(){},this.mib=r||new Mib,this.context="",this.forwarder=new Forwarder(this.listener,this.callback)};Agent.prototype.getMib=function(){return this.mib},Agent.prototype.setMib=function(e){this.mib=e},Agent.prototype.getAuthorizer=function(){return this.authorizer},Agent.prototype.registerProvider=function(e){this.mib.registerProvider(e)},Agent.prototype.registerProviders=function(e){this.mib.registerProviders(e)},Agent.prototype.unregisterProvider=function(e){this.mib.unregisterProvider(e)},Agent.prototype.getProvider=function(e){return this.mib.getProvider(e)},Agent.prototype.getProviders=function(){return this.mib.getProviders()},Agent.prototype.scalarReadCreateHandlerInternal=function(e){let t=e.provider;if(t&&void 0!==t.defVal)return t.defVal},Agent.prototype.tableRowStatusHandlerInternal=function(e){let t=e.provider,r=e.action,i=e.row,n=[],s=!1,o=Array.isArray(i)?i.slice(0):[i];return t.tableColumns.forEach((e=>{let i;i=t.tableIndex.filter((t=>e.number===t.columnNumber)),i.length>0?n.push(o.shift()):e.rowStatus?n.push(RowStatus[r]):"defVal"in e?n.push(e.defVal):(console.log("No defVal defined for column:",e),s=!0,n.push(void 0))})),s?void 0:n},Agent.prototype.onMsg=function(e,t){let r;try{r=Listener.processIncoming(e,this.authorizer,this.callback)}catch(r){return void this.callback(new ProcessingError("Failure to process incoming message",r,t,e))}if(r)if(r.version!=Version3||r.pdu.type!=PduType.GetRequest||r.hasAuthoritativeEngineID()||!r.isReportable())r.pdu.contextName&&""!=r.pdu.contextName?this.onProxyRequest(r,t):r.pdu.type==PduType.GetRequest?this.getRequest(r,t):r.pdu.type==PduType.SetRequest?this.setRequest(r,t):r.pdu.type==PduType.GetNextRequest?this.getNextRequest(r,t):r.pdu.type==PduType.GetBulkRequest?this.getBulkRequest(r,t):this.callback(new RequestInvalidError("Unexpected PDU type "+r.pdu.type+" ("+PduType[r.pdu.type]+")"));else{let e=r.createReportResponseMessage(this.engine,this.context);this.listener.send(e,t)}},Agent.prototype.castSetValue=function(e,t){switch(e){case ObjectType.Boolean:return!!t;case ObjectType.Integer:if("number"!=typeof t&&"string"!=typeof t)throw new Error("Invalid Integer",t);return"number"==typeof t?t:parseInt(t,10);case ObjectType.OctetString:if(t instanceof Buffer)return t.toString();if("string"!=typeof t)throw new Error("Invalid OctetString",t);return t;case ObjectType.OID:if("string"!=typeof t||!t.match(/[0-9]+\([.][0-9]+\)+/))throw new Error("Invalid OID",t);return t;case ObjectType.Counter:case ObjectType.Counter64:return 0;case ObjectType.IpAddress:var r=t.split(".");if("string"!=typeof t||4!=r.length)throw new Error("Invalid IpAddress",t);return t;default:return t}},Agent.prototype.tryCreateInstance=function(e,t){var r,i,n,s,o,a,u,d,c,p=this.mib.providersByOid,l=e.oid;for(a=Mib.convertOidToAddress(l).slice(0);a.length>0;a.pop())if(s=a.join("."),d=p[s]){if(d.type===MibProviderType.Scalar){if(d.maxAccess!=MaxAccess["read-create"])return;if(null===d.createHandler)return;if(c={provider:d},void 0===(n=(d.createHandler||this.scalarReadCreateHandlerInternal)(c)))return;return n=this.castSetValue(d.scalarType,n),this.mib.setScalarValue(d.name,n),{instanceNode:this.mib.lookup(l),providerType:MibProviderType.Scalar}}if(o=(s=Mib.getSubOidFromBaseOid(l,d.oid)).split("."),i=parseInt(o.shift(),10),r=Mib.getRowIndexFromOid(o.join("."),d.tableIndex),u=d.tableColumns.reduce(((e,t)=>t.rowStatus?t.number:e),null),t===PduType.SetRequest&&"number"==typeof u&&i===u&&(e.value===RowStatus.createAndGo||e.value===RowStatus.createAndWait)&&null!==d.createHandler){if(c={provider:d,action:RowStatus[e.value],row:r},void 0===(n=(d.createHandler||this.tableRowStatusHandlerInternal)(c)))return;if(!Array.isArray(n))throw new Error("createHandler must return an array or undefined; got",n);if(n.length!=d.tableColumns.length)throw new Error("createHandler's returned array must contain a value for for each column");return n=n.map(((e,t)=>this.castSetValue(d.tableColumns[t].type,e))),this.mib.addTableRow(d.name,n),{instanceNode:this.mib.lookup(l),providerType:MibProviderType.Table,action:RowStatus[e.value],rowIndex:r,row:n}}return}},Agent.prototype.isAllowed=function(e,t,r){var i,n,s;switch(t.type===MibProviderType.Scalar?n=t.maxAccess:(i=r.getTableColumnFromInstanceNode(),n=(s=t.tableColumns.find((e=>e.number===i)))&&s.maxAccess||MaxAccess["not-accessible"]),PduType[e]){case"SetRequest":return n>=MaxAccess["read-write"];case"GetRequest":case"GetNextRequest":case"GetBulkRequest":return n>=MaxAccess["read-only"];default:return!1}},Agent.prototype.request=function(e,t){var r=this,i=0,n=e.pdu,s=n.varbinds.length,o=n.getResponsePduForRequest(),a=[],u=[],d=[],c=[],p=e.version==Version3?e.user.name:e.community;for(let l=0;l<n.varbinds.length;l++){let h,g,y,m=this.mib.lookup(n.varbinds[l].oid);if(m||(d[l]=this.tryCreateInstance(n.varbinds[l],n.type),d[l]&&(m=d[l].instanceNode)),n.varbinds[l].oid.split(".").length<4&&(n.varbinds[l].oid="1.3.6.1"),m){if(h=this.mib.getProviderNodeForInstance(m),h&&void 0!==m.value)if(this.isAllowed(n.type,h.provider,m))if(this.authorizer.getAccessControlModelType()!=AccessControlModelType.Simple||this.authorizer.getAccessControlModel().isAccessAllowed(e.version,p,e.pdu.type)){if(n.type===PduType.SetRequest&&h.provider.type==MibProviderType.Table&&"number"==typeof(g=h.provider.tableColumns.reduce(((e,t)=>t.rowStatus?t.number:e),null))&&m.getTableColumnFromInstanceNode()===g)switch(y=function(e){e.done({errorStatus:ErrorStatus.InconsistentValue,type:ObjectType.Null,value:null})},n.varbinds[l].requestValue=this.castSetValue(n.varbinds[l].type,n.varbinds[l].value),n.varbinds[l].value){case RowStatus.active:case RowStatus.notInService:case RowStatus.destroy:break;case RowStatus.createAndGo:m.value===RowStatus.createAndGo?n.varbinds[l].value=RowStatus.active:(a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=y);break;case RowStatus.createAndWait:m.value===RowStatus.createAndWait?n.varbinds[l].value=RowStatus.notInService:(a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=y);break;case RowStatus.notReady:default:a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=y}}else a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=function(e){e.done({errorStatus:ErrorStatus.NoAccess,type:ObjectType.Null,value:null})};else a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=function(e){e.done({errorStatus:ErrorStatus.NoAccess,type:ObjectType.Null,value:null})};else a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=function(e){e.done({errorStatus:ErrorStatus.NoError,type:ObjectType.NoSuchInstance,value:null})};n.type!==PduType.SetRequest||d[l]||(c[l]=m.value),u[l]||(a[l]=new MibRequest({operation:n.type,providerNode:h,instanceNode:m,oid:n.varbinds[l].oid}),n.type==PduType.SetRequest&&(a[l].setType=n.varbinds[l].type,a[l].setValue=n.varbinds[l].requestValue||n.varbinds[l].value),u[l]=h.provider.handler)}else a[l]=new MibRequest({operation:n.type,oid:n.varbinds[l].oid}),u[l]=function(e){e.done({errorStatus:ErrorStatus.NoError,type:ObjectType.NoSuchObject,value:null})};!function(u){let p;a[u].done=function(l){let g=null,y=null,f=!1,b=-1;if(p={oid:a[u].oid},l)void 0!==o.errorStatus&&o.errorStatus!=ErrorStatus.NoError||l.errorStatus==ErrorStatus.NoError||(o.errorStatus=l.errorStatus,o.errorIndex=u+1),p.type=l.type||ObjectType.Null,p.value=l.value||null,l.errorStatus!=ErrorStatus.NoError&&(p.errorStatus=l.errorStatus);else{let e,t,i=h?h.provider:null,s=i?i.name:null;if(h&&h.provider&&h.provider.type==MibProviderType.Table&&(b=m.getTableColumnFromInstanceNode(),e=Mib.getSubOidFromBaseOid(m.oid,i.oid),t=e.split("."),t.shift(),g=Mib.getRowIndexFromOid(t.join("."),i.tableIndex),y=r.mib.getTableRowCells(s,g)),n.type==PduType.SetRequest){let e=i.type==MibProviderType.Table?i.tableColumns.reduce(((e,t)=>t.rowStatus?t.number:e),null):null;if(n.varbinds[u].value===RowStatus.destroy&&"number"==typeof e&&b===e)r.mib.deleteTableRow(s,g),f=!0;else{a[u].instanceNode.setValue(r.castSetValue(n.varbinds[u].type,n.varbinds[u].value))||(void 0!==o.errorStatus&&o.errorStatus!=ErrorStatus.NoError||(o.errorStatus=ErrorStatus.WrongValue,o.errorIndex=u+1),p.errorStatus=ErrorStatus.WrongValue)}}n.type!=PduType.GetNextRequest&&n.type!=PduType.GetBulkRequest||n.varbinds[u].type!=ObjectType.EndOfMibView?p.type=a[u].instanceNode.valueType:p.type=ObjectType.EndOfMibView,p.value=a[u].instanceNode.value}h&&h.provider&&h.provider.name&&(p.providerName=h.provider.name),n.type!=PduType.GetNextRequest&&n.type!=PduType.GetNextRequest||(p.previousOid=n.varbinds[u].previousOid),n.type==PduType.SetRequest&&(void 0!==c[u]&&(p.oldValue=c[u]),p.requestType=n.varbinds[u].type,n.varbinds[u].requestValue?p.requestValue=r.castSetValue(n.varbinds[u].type,n.varbinds[u].requestValue):p.requestValue=r.castSetValue(n.varbinds[u].type,n.varbinds[u].value)),d[u]?p.autoCreated=!0:f&&(p.deleted=!0),h&&h.provider.type==MibProviderType.Table&&(p.column=b,p.columnPosition=h.provider.tableColumns.findIndex((e=>e.number==b)),p.rowIndex=g,!f&&g&&(y=r.mib.getTableRowCells(h.provider.name,g)),p.row=y),r.setSingleVarbind(o,u,p),++i==s&&r.sendResponse.call(r,t,e,o)}}(l),u[l]?u[l](a[l]):a[l].done()}},Agent.prototype.getRequest=function(e,t){this.request(e,t)},Agent.prototype.setRequest=function(e,t){this.request(e,t)},Agent.prototype.addGetNextVarbind=function(e,t){var r,i;try{r=this.mib.lookup(t)}catch(e){t="1.3.6.1",r=this.mib.lookup(t)}return r||(r=this.mib.getTreeNode(t)),(i=r.getNextInstanceNode())?e.push({previousOid:t,oid:i.oid,type:i.valueType,value:i.value}):e.push({previousOid:t,oid:t,type:ObjectType.EndOfMibView,value:null}),i},Agent.prototype.getNextRequest=function(e,t){for(var r=e.pdu,i=r.varbinds.length,n=[],s=0;s<i;s++)this.addGetNextVarbind(n,r.varbinds[s].oid);e.pdu.varbinds=n,this.request(e,t)},Agent.prototype.getBulkRequest=function(e,t){for(var r,i=e.pdu,n=i.varbinds,s=[],o=[],a=!1,u=0;u<Math.min(i.nonRepeaters,n.length);u++)this.addGetNextVarbind(s,n[u].oid);if(i.nonRepeaters<n.length){for(var d=i.nonRepeaters;d<n.length;d++)o.push(n[d].oid);for(;s.length<i.maxRepetitions&&!a;)for(var c=i.nonRepeaters;c<n.length;c++)s.length<i.maxRepetitions&&(r=this.addGetNextVarbind(s,o[c-i.nonRepeaters]))&&(o[c-i.nonRepeaters]=r.oid,r.type==ObjectType.EndOfMibView&&(a=!0))}e.pdu.varbinds=s,this.request(e,t)},Agent.prototype.setSingleVarbind=function(e,t,r){e.varbinds[t]=r},Agent.prototype.sendResponse=function(e,t,r){var i=t.createResponseForRequest(r);this.listener.send(i,e),this.callback(null,Listener.formatCallbackData(i.pdu,e))},Agent.prototype.onProxyRequest=function(e,t){var r,i,n,s=e.pdu.contextName;if(e.version==Version3)if(r=this.forwarder.getProxy(s))if(r.session.msgSecurityParameters){e.msgSecurityParameters=r.session.msgSecurityParameters,e.setAuthentication(!(r.user.level==SecurityLevel.noAuthNoPriv)),e.setPrivacy(r.user.level==SecurityLevel.authPriv),n=e.user,e.user=r.user,e.buffer=null,e.pdu.contextEngineID=r.session.msgSecurityParameters.msgAuthoritativeEngineID,e.pdu.contextName="",i=e.pdu.id,e.pdu.id=_generateId();var o=new Req(r.session,e,null,this.callback,{},!0);o.port=r.port,o.proxiedRinfo=t,o.proxiedPduId=i,o.proxiedUser=n,o.proxiedEngine=this.engine,r.session.send(o)}else r.session.sendV3Discovery(null,null,this.callback,{});else this.callback(new RequestFailedError("No proxy found for message received with context "+s));else this.callback(new RequestFailedError("Only SNMP version 3 contexts are supported"))},Agent.prototype.getForwarder=function(){return this.forwarder},Agent.prototype.close=function(){this.listener.close()},Agent.create=function(e,t,r){var i=new Agent(e,t,r);return i.listener.startListening(),i};var Forwarder=function(e,t){this.proxies={},this.listener=e,this.callback=t};Forwarder.prototype.addProxy=function(e){var t={version:Version3,port:e.port,transport:e.transport};e.session=Session.createV3(e.target,e.user,t),e.session.proxy=e,e.session.proxy.listener=this.listener,this.proxies[e.context]=e,e.session.sendV3Discovery(null,null,this.callback)},Forwarder.prototype.deleteProxy=function(e){var t=this.proxies[e];t&&t.session&&t.session.close(),delete this.proxies[e]},Forwarder.prototype.getProxy=function(e){return this.proxies[e]},Forwarder.prototype.getProxies=function(){return this.proxies},Forwarder.prototype.dumpProxies=function(){var e={};for(var t of Object.values(this.proxies))e[t.context]={context:t.context,target:t.target,user:t.user,port:t.port};console.log(JSON.stringify(e,null,2))};var AgentXPdu=function(){};AgentXPdu.prototype.toBuffer=function(){var e=new smartbuffer.SmartBuffer;switch(this.writeHeader(e),this.pduType){case AgentXPduType.Open:e.writeUInt32BE(this.timeout),AgentXPdu.writeOid(e,this.oid),AgentXPdu.writeOctetString(e,this.descr);break;case AgentXPduType.Close:e.writeUInt8(5),e.writeUInt8(0),e.writeUInt8(0),e.writeUInt8(0);break;case AgentXPduType.Register:e.writeUInt8(this.timeout),e.writeUInt8(this.priority),e.writeUInt8(this.rangeSubid),e.writeUInt8(0),AgentXPdu.writeOid(e,this.oid);break;case AgentXPduType.Unregister:e.writeUInt8(0),e.writeUInt8(this.priority),e.writeUInt8(this.rangeSubid),e.writeUInt8(0),AgentXPdu.writeOid(e,this.oid);break;case AgentXPduType.AddAgentCaps:AgentXPdu.writeOid(e,this.oid),AgentXPdu.writeOctetString(e,this.descr);break;case AgentXPduType.RemoveAgentCaps:AgentXPdu.writeOid(e,this.oid);break;case AgentXPduType.Notify:AgentXPdu.writeVarbinds(e,this.varbinds);break;case AgentXPduType.Ping:break;case AgentXPduType.Response:e.writeUInt32BE(this.sysUpTime),e.writeUInt16BE(this.error),e.writeUInt16BE(this.index),AgentXPdu.writeVarbinds(e,this.varbinds)}return e.writeUInt32BE(e.length-20,16),e.toBuffer()},AgentXPdu.prototype.writeHeader=function(e){return this.flags=16|this.flags,e.writeUInt8(1),e.writeUInt8(this.pduType),e.writeUInt8(this.flags),e.writeUInt8(0),e.writeUInt32BE(this.sessionID),e.writeUInt32BE(this.transactionID),e.writeUInt32BE(this.packetID),e.writeUInt32BE(0),e},AgentXPdu.prototype.readHeader=function(e){this.version=e.readUInt8(),this.pduType=e.readUInt8(),this.flags=e.readUInt8(),e.readUInt8(),this.sessionID=e.readUInt32BE(),this.transactionID=e.readUInt32BE(),this.packetID=e.readUInt32BE(),this.payloadLength=e.readUInt32BE()},AgentXPdu.createFromVariables=function(e){var t=new AgentXPdu;switch(t.flags=e.flags?16|e.flags:16,t.pduType=e.pduType||AgentXPduType.Open,t.sessionID=e.sessionID||0,t.transactionID=e.transactionID||0,t.packetID=e.packetID||++AgentXPdu.packetID,t.pduType){case AgentXPduType.Open:t.timeout=e.timeout||0,t.oid=e.oid||null,t.descr=e.descr||null;break;case AgentXPduType.Close:break;case AgentXPduType.Register:t.timeout=e.timeout||0,t.oid=e.oid||null,t.priority=e.priority||127,t.rangeSubid=e.rangeSubid||0;break;case AgentXPduType.Unregister:t.oid=e.oid||null,t.priority=e.priority||127,t.rangeSubid=e.rangeSubid||0;break;case AgentXPduType.AddAgentCaps:t.oid=e.oid,t.descr=e.descr;break;case AgentXPduType.RemoveAgentCaps:t.oid=e.oid;break;case AgentXPduType.Notify:t.varbinds=e.varbinds;break;case AgentXPduType.Ping:break;case AgentXPduType.Response:t.sysUpTime=e.sysUpTime||0,t.error=e.error||0,t.index=e.index||0,t.varbinds=e.varbinds||null;break;default:throw new RequestInvalidError("Unknown PDU type '"+t.pduType+"' in created PDU")}return t},AgentXPdu.createFromBuffer=function(e){var t=new AgentXPdu,r=smartbuffer.SmartBuffer.fromBuffer(e);switch(t.readHeader(r),t.pduType){case AgentXPduType.Response:t.sysUpTime=r.readUInt32BE(),t.error=r.readUInt16BE(),t.index=r.readUInt16BE();break;case AgentXPduType.Get:case AgentXPduType.GetNext:t.searchRangeList=AgentXPdu.readSearchRangeList(r,t.payloadLength);break;case AgentXPduType.GetBulk:t.nonRepeaters=r.readUInt16BE(),t.maxRepetitions=r.readUInt16BE(),t.searchRangeList=AgentXPdu.readSearchRangeList(r,t.payloadLength-4);break;case AgentXPduType.TestSet:t.varbinds=AgentXPdu.readVarbinds(r,t.payloadLength);break;case AgentXPduType.CommitSet:case AgentXPduType.UndoSet:case AgentXPduType.CleanupSet:break;default:throw new RequestInvalidError("Unknown PDU type '"+t.pduType+"' in request")}return t},AgentXPdu.writeOid=function(e,t,r=0){var i;if(t){var n=t.split(".").map(Number);n.length>=5&&"1.3.6.1"==n.slice(0,4).join(".")?(i=n[4],n=n.slice(5)):i=0,e.writeUInt8(n.length),e.writeUInt8(i),e.writeUInt8(r),e.writeUInt8(0);for(let t of n)e.writeUInt32BE(t)}else e.writeUInt32BE(0)},AgentXPdu.writeOctetString=function(e,t){e.writeUInt32BE(t.length),e.writeString(t);var r=(4-t.length%4)%4;for(let t=0;t<r;t++)e.writeUInt8(0)},AgentXPdu.writeVarBind=function(e,t){if(e.writeUInt16BE(t.type),e.writeUInt16BE(0),AgentXPdu.writeOid(e,t.oid),t.type&&t.oid)switch(t.type){case ObjectType.Integer:case ObjectType.Counter:case ObjectType.Gauge:case ObjectType.TimeTicks:e.writeUInt32BE(t.value);break;case ObjectType.OctetString:case ObjectType.Opaque:AgentXPdu.writeOctetString(e,t.value);break;case ObjectType.OID:AgentXPdu.writeOid(e,t.value);break;case ObjectType.IpAddress:var r=t.value.split(".");if(4!=r.length)throw new RequestInvalidError("Invalid IP address '"+t.value+"'");e.writeOctetString(e,Buffer.from(r));break;case ObjectType.Counter64:e.writeUint64(t.value);break;case ObjectType.Null:case ObjectType.EndOfMibView:case ObjectType.NoSuchObject:case ObjectType.NoSuchInstance:break;default:throw new RequestInvalidError("Unknown type '"+t.type+"' in request")}},AgentXPdu.writeVarbinds=function(e,t){if(t)for(var r=0;r<t.length;r++){var i=t[r];AgentXPdu.writeVarBind(e,i)}},AgentXPdu.readOid=function(e){var t=e.readUInt8(),r=e.readUInt8(),i=e.readUInt8();if(e.readUInt8(),0==t&&0==r&&0==i)return null;var n=[];n=0==r?[]:[1,3,6,1,r];for(let r=0;r<t;r++)n.push(e.readUInt32BE());return n.join(".")},AgentXPdu.readSearchRange=function(e){return{start:AgentXPdu.readOid(e),end:AgentXPdu.readOid(e)}},AgentXPdu.readSearchRangeList=function(e,t){for(var r=t,i=e.readOffset+1,n=[];r>0;)n.push(AgentXPdu.readSearchRange(e)),r-=e.readOffset+1-i,i=e.readOffset+1;return n},AgentXPdu.readOctetString=function(e){var t=e.readUInt32BE(),r=(4-t%4)%4,i=e.readString(t);return e.readString(r),i},AgentXPdu.readVarbind=function(e){var t=e.readUInt16BE();e.readUInt16BE();var r,i=AgentXPdu.readOid(e);switch(t){case ObjectType.Integer:case ObjectType.Counter:case ObjectType.Gauge:case ObjectType.TimeTicks:r=e.readUInt32BE();break;case ObjectType.OctetString:case ObjectType.IpAddress:case ObjectType.Opaque:r=AgentXPdu.readOctetString(e);break;case ObjectType.OID:r=AgentXPdu.readOid(e);break;case ObjectType.Counter64:r=readUint64(e);break;case ObjectType.Null:case ObjectType.NoSuchObject:case ObjectType.NoSuchInstance:case ObjectType.EndOfMibView:r=null;break;default:throw new RequestInvalidError("Unknown type '"+t+"' in varbind")}return{type:t,oid:i,value:r}},AgentXPdu.readVarbinds=function(e,t){for(var r=t,i=e.readOffset+1,n=[];r>0;)n.push(AgentXPdu.readVarbind(e)),r-=e.readOffset+1-i,i=e.readOffset+1;return n},AgentXPdu.packetID=1;var Subagent=function(e){DEBUG=e.debug,this.mib=new Mib,this.master=e.master||"localhost",this.masterPort=e.masterPort||705,this.timeout=e.timeout||0,this.descr=e.description||"Node net-snmp AgentX sub-agent",this.sessionID=0,this.transactionID=0,this.packetID=_generateId(),this.requestPdus={},this.setTransactions={}};util.inherits(Subagent,events.EventEmitter),Subagent.prototype.onClose=function(){this.emit("close")},Subagent.prototype.onError=function(e){this.emit("error",e)},Subagent.prototype.getMib=function(){return this.mib},Subagent.prototype.connectSocket=function(){var e=this;this.socket=new net.Socket,this.socket.connect(this.masterPort,this.master,(function(){debug("Connected to '"+e.master+"' on port "+e.masterPort)})),this.socket.on("data",e.onMsg.bind(e)),this.socket.on("error",e.onError.bind(e)),this.socket.on("close",e.onClose.bind(e))},Subagent.prototype.open=function(e){var t=AgentXPdu.createFromVariables({pduType:AgentXPduType.Open,timeout:this.timeout,oid:this.oid,descr:this.descr});this.sendPdu(t,e)},Subagent.prototype.close=function(e){var t=AgentXPdu.createFromVariables({pduType:AgentXPduType.Close,sessionID:this.sessionID});this.sendPdu(t,e)},Subagent.prototype.registerProvider=function(e,t){var r=AgentXPdu.createFromVariables({pduType:AgentXPduType.Register,sessionID:this.sessionID,rangeSubid:0,timeout:5,priority:127,oid:e.oid});this.mib.registerProvider(e),this.sendPdu(r,t)},Subagent.prototype.unregisterProvider=function(e,t){var r=this.getProvider(e),i=AgentXPdu.createFromVariables({pduType:AgentXPduType.Unregister,sessionID:this.sessionID,rangeSubid:0,priority:127,oid:r.oid});this.mib.unregisterProvider(e),this.sendPdu(i,t)},Subagent.prototype.registerProviders=function(e,t){for(var r of e)this.registerProvider(r,t)},Subagent.prototype.getProvider=function(e){return this.mib.getProvider(e)},Subagent.prototype.getProviders=function(){return this.mib.getProviders()},Subagent.prototype.addAgentCaps=function(e,t,r){var i=AgentXPdu.createFromVariables({pduType:AgentXPduType.AddAgentCaps,sessionID:this.sessionID,oid:e,descr:t});this.sendPdu(i,r)},Subagent.prototype.removeAgentCaps=function(e,t){var r=AgentXPdu.createFromVariables({pduType:AgentXPduType.RemoveAgentCaps,sessionID:this.sessionID,oid:e});this.sendPdu(r,t)},Subagent.prototype.notify=function(e,t,r){t=t||[],"string"!=typeof e&&(e="1.3.6.1.6.3.1.1.5."+(e+1));var i=[{oid:"1.3.6.1.2.1.1.3.0",type:ObjectType.TimeTicks,value:Math.floor(100*process.uptime())},{oid:"1.3.6.1.6.3.1.1.4.1.0",type:ObjectType.OID,value:e}];i=i.concat(t);var n=AgentXPdu.createFromVariables({pduType:AgentXPduType.Notify,sessionID:this.sessionID,varbinds:i});this.sendPdu(n,r)},Subagent.prototype.ping=function(e){var t=AgentXPdu.createFromVariables({pduType:AgentXPduType.Ping,sessionID:this.sessionID});this.sendPdu(t,e)},Subagent.prototype.sendPdu=function(e,t){debug("Sending AgentX "+AgentXPduType[e.pduType]+" PDU"),debug(e);var r=e.toBuffer();this.socket.write(r),e.pduType==AgentXPduType.Response||this.requestPdus[e.packetID]||(e.callback=t,this.requestPdus[e.packetID]=e)},Subagent.prototype.onMsg=function(e,t){var r=AgentXPdu.createFromBuffer(e);switch(debug("Received AgentX "+AgentXPduType[r.pduType]+" PDU"),debug(r),r.pduType){case AgentXPduType.Response:this.response(r);break;case AgentXPduType.Get:this.getRequest(r);break;case AgentXPduType.GetNext:this.getNextRequest(r);break;case AgentXPduType.GetBulk:this.getBulkRequest(r);break;case AgentXPduType.TestSet:this.testSet(r);break;case AgentXPduType.CommitSet:this.commitSet(r);break;case AgentXPduType.UndoSet:this.undoSet(r);break;case AgentXPduType.CleanupSet:this.cleanupSet(r);break;default:throw new RequestInvalidError("Unknown PDU type '"+r.pduType+"' in request")}},Subagent.prototype.response=function(e){var t=this.requestPdus[e.packetID];if(!t)throw new ResponseInvalidError("Unexpected Response PDU with packetID "+e.packetID,ResponseInvalidCode.EUnexpectedResponse);switch(delete this.requestPdus[e.packetID],t.pduType){case AgentXPduType.Open:this.sessionID=e.sessionID;break;case AgentXPduType.Close:this.socket.end();break;case AgentXPduType.Register:case AgentXPduType.Unregister:case AgentXPduType.AddAgentCaps:case AgentXPduType.RemoveAgentCaps:case AgentXPduType.Notify:case AgentXPduType.Ping:break;default:throw new ResponseInvalidError("Response PDU for type '"+t.pduType+"' not handled",ResponseInvalidCode.EResponseNotHandled)}t.callback&&t.callback(null,e)},Subagent.prototype.request=function(e,t){for(var r=this,i=0,n=t.length,s=[],o=0;o<t.length;o++){var a,u,d,c,p=t[o],l=this.mib.lookup(p.oid);l?(a=this.mib.getProviderNodeForInstance(l))?(u=new MibRequest({operation:e.pduType,providerNode:a,instanceNode:l,oid:p.oid}),e.pduType==AgentXPduType.TestSet&&(u.setType=p.type,u.setValue=p.value),d=a.provider.handler):(u=new MibRequest({operation:e.pduType,oid:p.oid}),d=function(e){e.done({errorStatus:ErrorStatus.NoError,errorIndex:0,type:ObjectType.NoSuchInstance,value:null})}):(u=new MibRequest({operation:e.pduType,oid:p.oid}),d=function(e){e.done({errorStatus:ErrorStatus.NoError,errorIndex:0,type:ObjectType.NoSuchObject,value:null})}),function(t){var o;u.done=function(a){a?o={oid:u.oid,type:a.type||ObjectType.Null,value:a.value||null}:(e.pduType==AgentXPduType.TestSet||(e.pduType==AgentXPduType.CommitSet?(r.setTransactions[e.transactionID].originalValue=u.instanceNode.value,u.instanceNode.value=p.value):e.pduType==AgentXPduType.UndoSet&&(u.instanceNode.value=r.setTransactions[e.transactionID].originalValue)),c=e.pduType!=AgentXPduType.GetNext&&e.pduType!=AgentXPduType.GetBulk||p.type!=ObjectType.EndOfMibView?u.instanceNode.valueType:ObjectType.EndOfMibView,o={oid:u.oid,type:c,value:u.instanceNode.value}),s[t]=o,++i==n&&(e.pduType==AgentXPduType.TestSet||e.pduType==AgentXPduType.CommitSet||e.pduType==AgentXPduType.UndoSet?r.sendSetResponse.call(r,e):r.sendGetResponse.call(r,e,s))}}(o),d?d(u):u.done()}},Subagent.prototype.addGetNextVarbind=function(e,t){var r,i;try{r=this.mib.lookup(t)}catch(e){t="1.3.6.1",r=this.mib.lookup(t)}return r||(r=this.mib.getTreeNode(t)),(i=r.getNextInstanceNode())?e.push({oid:i.oid,type:i.valueType,value:i.value}):e.push({oid:t,type:ObjectType.EndOfMibView,value:null}),i},Subagent.prototype.getRequest=function(e){for(var t=[],r=0;r<e.searchRangeList.length;r++)t.push({oid:e.searchRangeList[r].start,value:null,type:null});this.request(e,t)},Subagent.prototype.getNextRequest=function(e){for(var t=[],r=0;r<e.searchRangeList.length;r++)this.addGetNextVarbind(t,e.searchRangeList[r].start);this.request(e,t)},Subagent.prototype.getBulkRequest=function(e){for(var t,r=[],i=[],n=!1,s=0;s<e.nonRepeaters;s++)this.addGetNextVarbind(r,e.searchRangeList[s].start);for(var o=e.nonRepeaters;o<e.searchRangeList.length;o++)i.push(e.searchRangeList[o].oid);for(;r.length<e.maxRepetitions&&!n;)for(var a=e.nonRepeaters;a<e.searchRangeList.length;a++)r.length<e.maxRepetitions&&(t=this.addGetNextVarbind(r,i[a-e.nonRepeaters]))&&(i[a-e.nonRepeaters]=t.oid,t.type==ObjectType.EndOfMibView&&(n=!0));this.request(e,r)},Subagent.prototype.sendGetResponse=function(e,t){var r=AgentXPdu.createFromVariables({pduType:AgentXPduType.Response,sessionID:e.sessionID,transactionID:e.transactionID,packetID:e.packetID,sysUpTime:0,error:0,index:0,varbinds:t});this.sendPdu(r,null)},Subagent.prototype.sendSetResponse=function(e){var t=AgentXPdu.createFromVariables({pduType:AgentXPduType.Response,sessionID:e.sessionID,transactionID:e.transactionID,packetID:e.packetID,sysUpTime:0,error:0,index:0});this.sendPdu(t,null)},Subagent.prototype.testSet=function(e){this.setTransactions[e.transactionID]=e,this.request(e,e.varbinds)},Subagent.prototype.commitSet=function(e){if(!this.setTransactions[e.transactionID])throw new RequestInvalidError("Unexpected CommitSet PDU with transactionID "+e.transactionID);this.request(e,this.setTransactions[e.transactionID].varbinds)},Subagent.prototype.undoSet=function(e){if(!this.setTransactions[e.transactionID])throw new RequestInvalidError("Unexpected UndoSet PDU with transactionID "+e.transactionID);this.request(e,this.setTransactions[e.transactionID].varbinds)},Subagent.prototype.cleanupSet=function(e){if(!this.setTransactions[e.transactionID])throw new RequestInvalidError("Unexpected CleanupSet PDU with transactionID "+e.transactionID);delete this.setTransactions[e.transactionID]},Subagent.create=function(e){var t=new Subagent(e);return t.connectSocket(),t},exports.Session=Session,exports.createSession=Session.create,exports.createV3Session=Session.createV3,exports.createReceiver=Receiver.create,exports.createAgent=Agent.create,exports.createModuleStore=ModuleStore.create,exports.createSubagent=Subagent.create,exports.createMib=Mib.create,exports.isVarbindError=isVarbindError,exports.varbindError=varbindError,exports.Version1=Version1,exports.Version2c=Version2c,exports.Version3=Version3,exports.Version=Version,exports.ErrorStatus=ErrorStatus,exports.TrapType=TrapType,exports.ObjectType=ObjectType,exports.PduType=PduType,exports.AgentXPduType=AgentXPduType,exports.MibProviderType=MibProviderType,exports.SecurityLevel=SecurityLevel,exports.AuthProtocols=AuthProtocols,exports.PrivProtocols=PrivProtocols,exports.AccessControlModelType=AccessControlModelType,exports.AccessLevel=AccessLevel,exports.MaxAccess=MaxAccess,exports.RowStatus=RowStatus,exports.ResponseInvalidCode=ResponseInvalidCode,exports.ResponseInvalidError=ResponseInvalidError,exports.RequestInvalidError=RequestInvalidError,exports.RequestFailedError=RequestFailedError,exports.RequestTimedOutError=RequestTimedOutError,exports.ObjectParser={readInt32:readInt32,readUint32:readUint32,readVarbindValue:readVarbindValue},exports.Authentication=Authentication,exports.Encryption=Encryption;